/**
* BY: haole zheng
* http://passer-by.com
*/
!function (root, factory) {
	if (typeof module === 'object' && module.exports){
		module.exports = factory();
	}else{
		root.relationship = factory();
	}
}(typeof window !== 'undefined' ? window : this,function (){
	//简写
	var _filter = [
		/* 表亲 */
		{//表亲的关系
			exp:/^(.+)&o([^#]+)&l/g,
			str:'$1$2'
		},
		{//表亲的关系
			exp:/^(.+)&l([^#]+)&o/g,
			str:'$1$2'
		},
		{//表亲的关系
			exp:/(,[ds],(.+),[ds])&[ol]/g,
			str:'$1'
		},
		/* 兄弟姐妹 */
		{//哥哥姐姐的哥哥姐姐还是自己的哥哥姐姐(年龄判断)
			exp:/(,o[sb])+(,o[sb])/,
			str:'$2'
		},
		{//弟弟妹妹的弟弟妹妹还是自己的弟弟妹妹(年龄判断)
			exp:/(,l[sb])+(,l[sb])/,
			str:'$2'
		},
		{//如果自己是男性,兄弟姐妹的兄弟就是自己的兄弟或自己
			exp:/^(.*)(,[fh1])(,[olx][sb])+,[olx]b(.*)$/,
			str:'$1$2,xb$4#$1$2$4'
		},
		{//如果自己是女性,兄弟姐妹的姐妹就是自己的姐妹或自己
			exp:/^(.*)(,[mw0])(,[olx][sb])+,[olx]s(.*)$/,
			str:'$1$2,xs$4#$1$2$4'
		},
		{//如果自己是男性,兄弟姐妹的姐妹就是自己的姐妹
			exp:/(,[fh1])(,[olx][sb])+,[olx]s/g,
			str:'$1,xs'
		},
		{//如果自己是女性,兄弟姐妹的兄弟就是自己的兄弟
			exp:/(,[mw0])(,[olx][sb])+,[olx]b/g,
			str:'$1,xb'
		},
		{//不知道性别，兄弟姐妹的兄弟是自己或兄弟
			exp:/^,[olx][sb],[olx]b(.+)?$/,
			str:'$1#,xb$1'
		},
		{//不知道性别，兄弟姐妹的姐妹是自己或姐妹
			exp:/^,[olx][sb],[olx]s(.+)?$/,
			str:'$1#,xs$1'
		},
		{//将复合称谓拆分
			exp:/^,x([sb])$/,
			str:',o$1#,l$1'
		},
		/* 父母 */
		{//母亲的丈夫是自己的父亲
			exp:/m,h/g,
			str:'f'
		},
		{//父亲的妻子是自己的母亲
			exp:/f,w/g,
			str:'m'
		},
		{//兄弟的父母就是自己的父母
			exp:/,[xol][sb](,[mf])/g,
			str:'$1'
		},
		/* 父母的子女 */
		{//父母的女儿年龄判断是姐姐还是妹妹
			exp:/,[mf],d&([ol])/,
			str:',$1s'
		},
		{//父母的儿子年龄判断是哥哥还是弟弟
			exp:/,[mf],s&([ol])/,
			str:',$1b'
		},
		{//如果自己是男性,父母的儿子是自己或者兄弟
			exp:/^(.*)(,[fh1]|[xol]b),[mf],s(.*)$/,
			str:'$1$2,xb$3#$1$2$3'
		},
		{//如果自己是女性,父母的女儿是自己或者姐妹
			exp:/^(.*)(,[mw0]|[xol]s),[mf],d(.*)$/,
			str:'$1$2,xs$3#$1$2$3'
		},
		{//如果自己是女性,父母的儿子是自己兄弟
			exp:/(,[mw0]|[xol]s),[mf],s/,
			str:'$1,xb'
		},
		{//如果自己是男性,父母的女儿是自己姐妹
			exp:/(,[fh1]|[xol]b),[mf],d/,
			str:'$1,xs'
		},
		{//父母的儿子是自己或兄弟
			exp:/^,[mf],s(.+)?$/,
			str:',1$1#,xb$1'
		},
		{//父母的女儿是自己或者姐妹
			exp:/^,[mf],d(.+)?$/,
			str:',0$1#,xs$1'
		},
		/* 孩子 */
		{//孩子的姐妹是自己的女儿(年龄判断)
			exp:/,[ds]&o,ob/g,
			str:',s&o'
		},
		{//孩子的姐妹是自己的女儿(年龄判断)
			exp:/,[ds]&o,os/g,
			str:',d&o'
		},
		{//孩子的兄弟是自己的儿子(年龄判断)
			exp:/,[ds]&l,lb/g,
			str:',s&l'
		},
		{//孩子的兄弟是自己的儿子(年龄判断)
			exp:/,[ds]&l,ls/g,
			str:',d&l'
		},
		{//孩子的姐妹是自己的女儿
			exp:/,[ds](&[ol])?,[olx]s/g,
			str:',d'
		},
		{//孩子的兄弟是自己的儿子
			exp:/,[ds](&[ol])?,[olx]b/g,
			str:',s'
		},
		/* 夫妻 */
		{//自己是女性，女儿或儿子的妈妈是自己
			exp:/(,[mwd0](&[ol])?|[olx]s),[ds](&[ol])?,m/g,
			str:'$1'
		},
		{//自己是女性，女儿或儿子的爸爸是自己的丈夫
			exp:/(,[mwd0](&[ol])?|[olx]s),[ds](&[ol])?,f/g,
			str:'$1,h'
		},
		{//自己是男性，女儿或儿子的爸爸是自己
			exp:/(,[fhs1](&[ol])?|[olx]b),[ds](&[ol])?,f/g,
			str:'$1'
		},
		{//自己是男性，女儿或儿子的妈妈是自己的妻子
			exp:/(,[fhs1](&[ol])?|[olx]b),[ds](&[ol])?,m/g,
			str:'$1,w'
		},
		{//不知道性别，子女的妈妈是自己或妻子
			exp:/^,[ds],m(.+)?$/,
			str:'$1#,w$1'
		},
		{//不知道性别，子女的爸爸是自己或丈夫
			exp:/^,[ds],f(.+)?$/,
			str:'$1#,h$1'
		},
		{//夫妻的孩子就是自己的孩子
			exp:/,[wh](,[ds])/g,
			str:'$1'
		},
		{//夫妻的对方是自己
			exp:/,w,h|,h,w/g,
			str:''
		},
		{//并列关系处理1
			exp:/(.+)?\[([^\|]+?)\|([^\[\]]+?\|[^\[\]]+?)?\](.+)?/g,
			str:'$1$2$4#$1[$3]$4'
		},
		{//并列关系处理2
			exp:/(.+)?\[([^\[\]\|]+?)\|([^\[\]\|]+?)?\](.+)?/g,
			str:'$1$2$4#$1$3$4'
		}
	];

	//关系数据
	//语法说明：
	//【关系】f:父,m:母,h:夫,w:妻,s:子,d:女,xb:兄弟,ob:兄,lb:弟,xs:姐妹,os:姐,ls:妹
	//【修饰符】 1:男性,0:女性,&o:年长,&l:年幼,#:隔断,[a|b]:并列
	var _data = {
		'':['自己','我','本人','在下'],
		//并称
		'[f,f|f,m|m,f|m,m]':['祖辈','祖父母'],
		'[f|m]':['父母','爹娘','爹妈','爸妈','双亲','二亲','两亲','二老','高堂'],
		'[h,f|h,m]':['公婆'],
		'[w,f|w,m]':['岳父母'],
		'[xb|xs]':['兄弟姐妹','同胞','手足'],
		'[f,xb,s&o|f,xb,s&l]':['堂兄弟'],
		'[f,xb,d&o|f,xb,d&l]':['堂姐妹','堂姊妹'],
		'[f,xs,s&o|f,xs,s&l|m,xb,s&o|m,xb,s&l]':['表兄弟'],
		'[f,xs,d&o|f,xs,d&l|m,xb,d&o|m,xb,d&l]':['表姐妹','表姊妹'],
		'[s|d]':['子女','儿女','小孩','孩子','孩儿','宝宝','娃'],
		'[s,s|s,d|d,s|d,d]':['孙辈'],
		// 本家
		'f':['爸爸','父亲','阿爸','老爸','老窦','爸','父','爹','爹爹','爹地','爹啲','老爹','大大','老爷子'],
		// 爷爷
		'f,f':['爷爷','祖父','阿爷','奶爷','阿公','老爷'],
		'f,f,f':['曾祖父','曾祖','太爷','太爷爷','太公','祖公','祖奶爷','太老爷'],
		'f,f,f,f':['高祖父','老太奶爷','老太爷','祖太爷','祖太爷爷','祖太公','高王父'],
		'f,f,f,f,f':['天祖父','高祖'],
		'f,f,f,f,f,f':['烈祖父','烈祖'],
		'f,f,f,f,f,f,f':['太祖父','太祖'],
		'f,f,f,f,f,f,f,f':['远祖父','远祖'],
		'f,f,f,f,f,f,f,f,f':['鼻祖父','鼻祖','始祖'],
		'f,f,f,f,f,f,f,f,f,ob':['伯鼻祖父'],
		'f,f,f,f,f,f,f,f,f,ob,w':['伯鼻祖母'],
		'f,f,f,f,f,f,f,f,f,lb':['叔鼻祖父'],
		'f,f,f,f,f,f,f,f,f,lb,w':['叔鼻祖母'],
		'f,f,f,f,f,f,f,f,f,xs':['姑鼻祖母'],
		'f,f,f,f,f,f,f,f,f,xs,h':['姑鼻祖父'],
		'f,f,f,f,f,f,f,f,m':['鼻祖母'],
		'f,f,f,f,f,f,f,f,m,xs':['姨鼻祖母'],
		'f,f,f,f,f,f,f,f,m,xs,h':['姨鼻祖父'],
		'f,f,f,f,f,f,f,f,m,xb':['舅鼻祖父'],
		'f,f,f,f,f,f,f,f,m,xb,w':['舅鼻祖母'],
		'f,f,f,f,f,f,f,f,ob':['伯远祖父'],
		'f,f,f,f,f,f,f,f,ob,w':['伯远祖母'],
		'f,f,f,f,f,f,f,f,lb':['叔远祖父'],
		'f,f,f,f,f,f,f,f,lb,w':['叔远祖母'],
		'f,f,f,f,f,f,f,f,xs':['姑远祖母'],
		'f,f,f,f,f,f,f,f,xs,h':['姑远祖父'],
		'f,f,f,f,f,f,f,m':['远祖母'],
		'f,f,f,f,f,f,f,m,xs':['姨远祖母'],
		'f,f,f,f,f,f,f,m,xs,h':['姨远祖父'],
		'f,f,f,f,f,f,f,m,xb':['舅远祖父'],
		'f,f,f,f,f,f,f,m,xb,w':['舅远祖母'],
		'f,f,f,f,f,f,f,ob':['伯太祖父'],
		'f,f,f,f,f,f,f,ob,w':['伯太祖母'],
		'f,f,f,f,f,f,f,lb':['叔太祖父'],
		'f,f,f,f,f,f,f,lb,w':['叔太祖母'],
		'f,f,f,f,f,f,f,xs':['姑太祖母'],
		'f,f,f,f,f,f,f,xs,h':['姑太祖父'],
		'f,f,f,f,f,f,m':['太祖母'],
		'f,f,f,f,f,f,m,xs':['姨太祖母'],
		'f,f,f,f,f,f,m,xs,h':['姨太祖父'],
		'f,f,f,f,f,f,m,xb':['舅太祖父'],
		'f,f,f,f,f,f,m,xb,w':['舅太祖母'],
		'f,f,f,f,f,f,ob':['伯烈祖父'],
		'f,f,f,f,f,f,ob,w':['伯烈祖母'],
		'f,f,f,f,f,f,lb':['叔烈祖父'],
		'f,f,f,f,f,f,lb,w':['叔烈祖母'],
		'f,f,f,f,f,f,xs':['姑烈祖母'],
		'f,f,f,f,f,f,xs,h':['姑烈祖父'],
		'f,f,f,f,f,m':['烈祖母'],
		'f,f,f,f,f,m,xs':['姨烈祖母'],
		'f,f,f,f,f,m,xs,h':['姨烈祖父'],
		'f,f,f,f,f,m,xb':['舅烈祖父'],
		'f,f,f,f,f,m,xb,w':['舅烈祖母'],
		'f,f,f,f,f,ob':['伯天祖父'],
		'f,f,f,f,f,ob,w':['伯天祖母'],
		'f,f,f,f,f,lb':['叔天祖父'],
		'f,f,f,f,f,lb,w':['叔天祖母'],
		'f,f,f,f,f,xs':['姑天祖母'],
		'f,f,f,f,f,xs,h':['姑天祖父'],
		'f,f,f,f,m':['天祖母'],
		'f,f,f,f,m,xs':['姨天祖母'],
		'f,f,f,f,m,xs,h':['姨天祖父'],
		'f,f,f,f,m,xb':['舅天祖父'],
		'f,f,f,f,m,xb,w':['舅天祖母'],
		'f,f,f,f,ob':['伯高祖父'],
		'f,f,f,f,ob,w':['伯高祖母'],
		'f,f,f,f,lb':['叔高祖父'],
		'f,f,f,f,lb,w':['叔高祖母'],
		'f,f,f,f,xb,s&o':['堂曾伯祖父'],
		'f,f,f,f,xb,s&o,w':['堂曾伯祖母'],
		'f,f,f,f,xb,s&l':['堂曾叔祖父'],
		'f,f,f,f,xb,s&l,w':['堂曾叔祖母'],
		'f,f,f,f,xb,s,s&o':['从堂伯祖父'],
		'f,f,f,f,xb,s,s&o,w':['从堂伯祖母'],
		'f,f,f,f,xb,s,s&l':['从堂叔祖父'],
		'f,f,f,f,xb,s,s&l,w':['从堂叔祖母'],
		'f,f,f,f,xb,s,d':['从堂姑祖母'],
		'f,f,f,f,xb,s,d,h':['从堂姑祖父'],
		'f,f,f,f,xb,s,s,s&o':['再从堂伯父'],
		'f,f,f,f,xb,s,s,s&o,w':['再从堂伯母'],
		'f,f,f,f,xb,s,s,s&l':['再从堂叔父'],
		'f,f,f,f,xb,s,s,s&l,w':['再从堂叔母'],
		'f,f,f,f,xb,s,s,d':['再从堂姑母'],
		'f,f,f,f,xb,s,s,d,h':['再从堂姑父'],
		'f,f,f,f,xb,s,s,s,s&o':['三从堂兄'],
		'f,f,f,f,xb,s,s,s,s&o,w':['三从堂嫂'],
		'f,f,f,f,xb,s,s,s,s&l':['三从堂弟'],
		'f,f,f,f,xb,s,s,s,s&l,w':['三从堂弟媳'],
		'f,f,f,f,xb,s,s,s,s,d&o':['三从堂姐','三从堂姊'],
		'f,f,f,f,xb,s,s,s,s,d&o,h':['三从堂姐夫','三从堂姊夫'],
		'f,f,f,f,xb,s,s,s,s,d&l':['三从堂妹'],
		'f,f,f,f,xb,s,s,s,s,d&l,h':['三从堂妹夫'],
		'f,f,f,f,xb,d':['堂曾姑祖母'],
		'f,f,f,f,xb,d,h':['堂曾姑祖父'],
		'f,f,f,f,xs':['姑高祖母'],
		'f,f,f,f,xs,h':['姑高祖父'],
		'f,f,f,m':['高祖母','老太奶奶','老太太','祖太太','祖太奶','祖太奶奶','祖太婆','高王母'],
		'f,f,f,m,xs':['姨高祖母'],
		'f,f,f,m,xs,h':['姨高祖父'],
		'f,f,f,m,xb':['舅高祖父'],
		'f,f,f,m,xb,w':['舅高祖母'],
		// 从父*
		'f,f,f,ob':['伯曾祖父','曾伯祖父','曾伯父','太伯公','伯公太','伯太爷','伯公老爷','族曾祖父'],
		'f,f,f,ob,w':['伯曾祖母','曾伯祖母','曾伯母','太公婆','伯婆太','伯太太','伯婆奶奶','族曾祖母'],
		'f,f,f,lb':['叔曾祖父','曾叔祖父','曾叔父','太叔公','叔公太','叔太爷','叔公老爷','族曾祖父'],
		'f,f,f,lb,w':['叔曾祖母','曾叔祖母','曾叔母','太叔婆','叔婆太','叔太太','叔婆奶奶','族曾祖母'],
		// 再从父
		'f,f,f,xb,s&o':['堂伯祖父','从父伯祖父','叔伯伯祖父','族伯祖父','族祖父'],
		'f,f,f,xb,s&o,w':['堂伯祖母','从父伯祖母','叔伯伯祖母','族伯祖母','族祖母'],
		'f,f,f,xb,s&l':['堂叔祖父','从父叔祖父','叔伯叔祖父','族叔祖父','族祖父'],
		'f,f,f,xb,s&l,w':['堂叔祖母','从父叔祖母','叔伯叔祖母','族叔祖母','族祖母'],
		'f,f,f,xb,s&o':['堂伯祖父','从父伯祖父'],
		'f,f,f,xb,s&o,w':['堂伯祖母','从父伯祖母'],
		'f,f,f,xb,s&l':['堂叔祖父','从父叔祖父'],
		'f,f,f,xb,s&l,w':['堂叔祖母','从父叔祖母'],
		'f,f,f,xb,s,s&o':['从堂伯父','再从父伯父','叔伯叔伯伯父','族伯父','族父'],
		'f,f,f,xb,s,s&o,w':['从堂伯母','再从父伯母','叔伯叔伯伯母','族伯母','族母'],
		'f,f,f,xb,s,s&l':['从堂叔父','再从父叔父','叔伯叔伯叔父','族叔父','族父'],
		'f,f,f,xb,s,s&l,w':['从堂叔母','再从父叔母','叔伯叔伯叔母','族叔母','族母'],
		'f,f,f,xb,s,s,s&o':['再从堂兄','三从父兄','族兄'],
		'f,f,f,xb,s,s,s&o,w':['再从堂嫂','三从父嫂','族嫂'],
		'f,f,f,xb,s,s,s&l':['再从堂弟','三从父弟','族弟'],
		'f,f,f,xb,s,s,s&l,w':['再从堂弟媳','三从父弟媳','族弟媳'],
		'f,f,f,xb,s,s,s,s':['再从堂侄','三从父侄子','族侄子'],
		'f,f,f,xb,s,s,s,s,w':['再从堂侄媳','三从父侄媳','族侄媳'],
		'f,f,f,xb,s,s,s,s,s':['再从堂侄孙','三从父侄孙','族侄孙'],
		'f,f,f,xb,s,s,s,s,s,w':['再从堂侄孙媳','三从父侄孙媳','族侄孙媳'],
		'f,f,f,xb,s,s,s,s,d':['再从堂侄孙女','三从父侄孙女','族侄孙女'],
		'f,f,f,xb,s,s,s,s,d,h':['再从堂侄孙婿','三从父侄孙婿','族侄孙婿'],
		'f,f,f,xb,s,s,s,d':['再从堂侄女','三从父侄女','族侄女'],
		'f,f,f,xb,s,s,s,d,h':['再从堂侄女婿','三从父侄婿','族侄女婿'],
		'f,f,f,xb,s,s,s,d,s':['再从堂侄外孙','三从父侄外孙','族侄外孙'],
		'f,f,f,xb,s,s,s,d,s,w':['再从堂侄外孙媳','三从父侄外孙媳','族侄外孙媳'],
		'f,f,f,xb,s,s,s,d,d':['再从堂侄外孙女','三从父侄外孙女','族侄外孙女'],
		'f,f,f,xb,s,s,s,d,d,h':['再从堂侄外孙婿','三从父侄外孙婿','族侄外孙婿'],
		'f,f,f,xb,s,s,d&o':['再从堂姐','三从父姐','族姐','再从堂姊','三从父姊','族姊'],
		'f,f,f,xb,s,s,d&o,h':['再从堂姐夫','三从父姐夫','族姐夫','再从堂姊夫','三从父姊夫','族姊夫'],
		'f,f,f,xb,s,s,d&l':['再从堂妹','三从父妹','族妹'],
		'f,f,f,xb,s,s,d&l,h':['再从堂妹夫','三从父妹夫','族妹夫'],
		'f,f,f,xb,s,s,d,s':['再从堂外甥','三从父外甥','族外甥'],
		'f,f,f,xb,s,s,d,s,w':['再从堂外甥媳','三从父外甥媳','族外甥媳'],
		'f,f,f,xb,s,s,d,d':['再从堂外甥女','三从父外甥女','族外甥女'],
		'f,f,f,xb,s,s,d,d,h':['再从堂外甥婿','三从父外甥婿','族外甥婿'],
		'f,f,f,xb,s,d':['从堂姑母','再从父姑母'],
		'f,f,f,xb,s,d,h':['从堂姑父','再从父姑父'],
		// 从父姑表
		'f,f,f,xb,d':['堂姑祖母','从父姑祖母'],
		'f,f,f,xb,d,h':['堂姑祖父','从父姑祖父'],
		'f,f,f,xb,d,s&o':['堂姑表伯父','从父姑表伯父'],
		'f,f,f,xb,d,s&o,w':['堂姑表伯母','从父姑表伯母'],
		'f,f,f,xb,d,s&l':['堂姑表叔父','从父姑表叔父'],
		'f,f,f,xb,d,s&l,w':['堂姑表叔母','从父姑表叔母'],
		'f,f,f,xb,d,d':['堂姑表姑母','从父姑表姑母'],
		'f,f,f,xb,d,d,h':['堂姑表姑父','从父姑表姑父'],
		// 姑表*
		'f,f,f,xs':['姑曾祖母','曾祖姑母','太姑婆','姑婆太','姑太太','曾祖姑','姑婆奶奶'],
		'f,f,f,xs,h':['姑曾祖父','曾祖姑丈','太姑丈公','姑丈公太','姑太爷','姑公老爷'],
		// 姑表叔表
		'f,f,f,xs,s&o':['姑表伯祖父'],
		'f,f,f,xs,s&o,w':['姑表伯祖母'],
		'f,f,f,xs,s&l':['姑表叔祖父'],
		'f,f,f,xs,s&l,w':['姑表叔祖母'],
		'f,f,f,xs,s,s&o':['姑表叔表伯父'],
		'f,f,f,xs,s,s&o,w':['姑表叔表伯母'],
		'f,f,f,xs,s,s&l':['姑表叔表叔父'],
		'f,f,f,xs,s,s&l,w':['姑表叔表叔母'],
		'f,f,f,xs,s,d':['姑表叔表姑母'],
		'f,f,f,xs,s,d,h':['姑表叔表姑父'],
		// 姑表姑表
		'f,f,f,xs,d':['姑表姑祖母'],
		'f,f,f,xs,d,h':['姑表姑祖父'],
		'f,f,f,xs,d,s&o':['姑表姑表伯父'],
		'f,f,f,xs,d,s&o,w':['姑表姑表伯母'],
		'f,f,f,xs,d,s&l':['姑表姑表叔父'],
		'f,f,f,xs,d,s&l,w':['姑表姑表叔母'],
		'f,f,f,xs,d,d':['姑表姑表姑母'],
		'f,f,f,xs,d,d,h':['姑表姑表姑父'],
		'f,f,m':['曾祖母','太奶奶','太婆','祖婆','祖奶奶'],
		'f,f,m,f':['高外祖父','老太姥爷','祖太姥爷','祖太公','高王父'],
		'f,f,m,m':['高外祖母','老太姥姥','祖太姥姥','祖太姥娘','祖太婆','高王母'],
		// 舅表*
		'f,f,m,xb':['舅曾祖父','太舅公','太舅爷','舅太爷','舅太爷爷','舅公老爷'],
		'f,f,m,xb,w':['舅曾祖母','太舅婆','舅太太','舅太奶奶','舅婆奶奶'],
		// 舅表叔表
		'f,f,m,xb,s&o':['舅表伯祖父'],
		'f,f,m,xb,s&o,w':['舅表伯祖母'],
		'f,f,m,xb,s&l':['舅表叔祖父'],
		'f,f,m,xb,s&l,w':['舅表叔祖母'],
		'f,f,m,xb,s,s&o':['舅表叔表伯父'],
		'f,f,m,xb,s,s&o,w':['舅表叔表伯母'],
		'f,f,m,xb,s,s&l':['舅表叔表叔父'],
		'f,f,m,xb,s,s&l,w':['舅表叔表叔母'],
		'f,f,m,xb,s,d':['舅表叔表姑母'],
		'f,f,m,xb,s,d,h':['舅表叔表姑父'],
		// 舅表姑表
		'f,f,m,xb,d':['舅表姑祖母'],
		'f,f,m,xb,d,h':['舅表姑祖父'],
		'f,f,m,xb,d,s&o':['舅表姑表伯父'],
		'f,f,m,xb,d,s&o,w':['舅表姑表伯母'],
		'f,f,m,xb,d,s&l':['舅表姑表叔父'],
		'f,f,m,xb,d,s&l,w':['舅表姑表叔母'],
		'f,f,m,xb,d,d':['舅表姑表姑母'],
		'f,f,m,xb,d,d,h':['舅表姑表姑父'],
		// 从母*
		'f,f,m,xs':['姨曾祖母','太姨奶','姨太太','曾姨奶奶','姨太奶奶','姨婆奶奶'],
		'f,f,m,xs,h':['姨曾祖父','太姨爷','姨太爷','姨太爷爷'],
		// 从母叔表
		'f,f,m,xs,s&o':['从母伯祖父'],
		'f,f,m,xs,s&o,w':['从母伯祖母'],
		'f,f,m,xs,s&l':['从母叔祖父'],
		'f,f,m,xs,s&l,w':['从母叔祖母'],
		'f,f,m,xs,s,s&o':['从母叔表伯父'],
		'f,f,m,xs,s,s&o,w':['从母叔表伯母'],
		'f,f,m,xs,s,s&l':['从母叔表叔父'],
		'f,f,m,xs,s,s&l,w':['从母叔表叔母'],
		'f,f,m,xs,s,d':['从母叔表姑母'],
		'f,f,m,xs,s,d,h':['从母叔表姑父'],
		// 从母姑表
		'f,f,m,xs,d':['从母姑祖母'],
		'f,f,m,xs,d,h':['从母姑祖父'],
		'f,f,m,xs,d,s&o':['从母姑表伯父'],
		'f,f,m,xs,d,s&o,w':['从母姑表伯母'],
		'f,f,m,xs,d,s&l':['从母姑表叔父'],
		'f,f,m,xs,d,s&l,w':['从母姑表叔母'],
		'f,f,m,xs,d,d':['从母姑表姑母'],
		'f,f,m,xs,d,d,h':['从母姑表姑父'],
		// 从父*
		'f,f,ob':['伯公','伯祖父','伯老爷','大爷爷','大爷','堂祖父','伯爷爷'],
		'f,f,ob,w':['伯婆','伯祖母','伯奶奶','大奶奶','堂祖母','姆婆'],
		'f,f,lb':['叔公','叔祖父','叔老爷','小爷爷','堂祖父','叔爷爷','叔奶爷'],
		'f,f,lb,w':['叔婆','叔祖母','叔奶奶','小奶奶','堂祖母','婶婆'],
		'f,f,xb':['堂祖父','从祖祖父','从祖父','x爷爷','x大爷'],
		'f,f,xb,w':['堂祖母','从祖祖母','从祖母'],
		// 再从父
		'f,f,xb,s&o':['堂伯','堂伯父','从父伯父'],
		'f,f,xb,s&o,w':['堂伯母','从父伯母'],
		'f,f,xb,s&l':['堂叔','堂叔父','从父叔父','叔伯叔父'],
		'f,f,xb,s,w':['堂婶','堂叔母','堂婶母','从父叔母','叔伯叔母'],
		'f,f,xb,s,s&o':['从堂兄','再从父兄','从祖兄'],
		'f,f,xb,s,s&o,w':['从堂嫂','再从父嫂'],
		'f,f,xb,s,s&l':['从堂弟','再从父弟','从祖弟'],
		'f,f,xb,s,s&l,w':['从堂弟媳','再从父弟媳'],
		'f,f,xb,s,s,s':['从堂侄','再从父侄男'],
		'f,f,xb,s,s,s,w':['从堂侄媳','再从父侄媳'],
		'f,f,xb,s,s,s,s':['从堂侄孙','再从父侄孙'],
		'f,f,xb,s,s,s,s,w':['从堂侄孙媳','再从父侄孙媳'],
		'f,f,xb,s,s,s,d':['从堂侄孙女','再从父侄孙女'],
		'f,f,xb,s,s,s,d,h':['从堂侄孙女婿','再从父侄孙女婿'],
		'f,f,xb,s,s,d':['从堂侄女','再从父侄女'],
		'f,f,xb,s,s,d,h':['从堂侄婿','再从父侄婿'],
		'f,f,xb,s,s,d,s':['从堂侄外孙','再从父侄外孙'],
		'f,f,xb,s,s,d,s,w':['从堂侄外孙媳','再从父侄外孙媳'],
		'f,f,xb,s,s,d,d':['从堂侄外孙女','再从父外侄孙女'],
		'f,f,xb,s,s,d,d,h':['从堂侄外孙女婿','再从父外侄孙女婿'],
		'f,f,xb,s,d&o':['从堂姐','再从父姐','从堂姊','再从父姊','从祖姊'],
		'f,f,xb,s,d&o,h':['从堂姐夫','再从父姐夫','从堂姊夫','再从父姊夫'],
		'f,f,xb,s,d&l':['从堂妹','再从父妹','从祖妹'],
		'f,f,xb,s,d&l,h':['从堂妹夫','再从父妹夫'],
		'f,f,xb,s,d,s':['从堂外甥','再从父外甥'],
		'f,f,xb,s,d,s,w':['从堂父外甥媳','再从父外甥媳'],
		'f,f,xb,s,d,d':['从堂外甥女','再从父外甥女'],
		'f,f,xb,s,d,d,h':['从堂甥女婿','再从父甥女婿'],
		// 从父姑表
		'f,f,xb,d':['堂姑','堂姑妈','堂姑母','从父姑母','叔伯姑母'],
		'f,f,xb,d,h':['堂姑丈','堂姑爸','堂姑父','从父姑父','叔伯姑父'],
		'f,f,xb,d,s&o':['堂姑表兄','从父姑表兄'],
		'f,f,xb,d,s&o,w':['堂姑表嫂','从父姑表嫂'],
		'f,f,xb,d,s&l':['堂姑表弟','从父姑表弟'],
		'f,f,xb,d,s&l,h':['堂姑表弟媳','从父姑表弟媳'],
		'f,f,xb,d,s,s':['堂姑表侄男','从父姑表侄男'],
		'f,f,xb,d,s,s,w':['堂姑表侄妇','从父姑表侄妇'],
		'f,f,xb,d,s,d':['堂姑表侄女','从父姑表侄女'],
		'f,f,xb,d,s,d,h':['堂姑表侄婿','从父姑表侄婿'],
		'f,f,xb,d,d&o':['堂姑表姐','从父姑表姐','堂姑表姊','从父姑表姊'],
		'f,f,xb,d,d&o,h':['堂姑表姐夫','从父姑表姐夫','堂姑表姊夫','从父姑表姊夫'],
		'f,f,xb,d,d&l':['堂姑表妹','从父姑表妹'],
		'f,f,xb,d,d&l,h':['堂姑表妹夫','从父姑表妹夫'],
		'f,f,xb,d,d,s':['堂姑表甥男','从父姑表甥男'],
		'f,f,xb,d,d,s,w':['堂姑表甥妇','从父姑表甥妇'],
		'f,f,xb,d,d,d':['堂姑表甥女','从父姑表甥女'],
		'f,f,xb,d,d,d,h':['堂姑表甥婿','从父姑表甥婿'],
		// 姑表*
		'f,f,xs':['姑奶奶','姑内祖母','祖姑母','姑祖母','姑奶','姑婆','祖姑'],
		'f,f,xs,h':['姑爷爷','姑内祖父','祖姑父','姑祖父','姑老爷','姑公','姑奶爷','姑丈公'],
		// 姑表叔表
		'f,f,xs,s&o':['姑表伯父','表伯父','表伯'],
		'f,f,xs,s&o,w':['姑表伯母','表伯母'],
		'f,f,xs,s&l':['姑表叔父','表叔父','表叔爸','表叔'],
		'f,f,xs,s&l,w':['姑表叔母','表叔母','表叔妈','表婶'],
		'f,f,xs,s,s&o':['姑表叔表兄'],
		'f,f,xs,s,s&l':['姑表叔表弟'],
		'f,f,xs,s,s,s':['姑表叔表侄男'],
		'f,f,xs,s,s,s,w':['姑表叔表侄妇'],
		'f,f,xs,s,s,d':['姑表叔表侄女'],
		'f,f,xs,s,s,d,h':['姑表叔表侄婿'],
		'f,f,xs,s,d&o':['姑表叔表姊'],
		'f,f,xs,s,d&l':['姑表叔表妹'],
		'f,f,xs,s,d,s':['姑表叔表甥男'],
		'f,f,xs,s,d,s,w':['姑表叔表甥妇'],
		'f,f,xs,s,d,d':['姑表叔表甥女'],
		'f,f,xs,s,d,d,h':['姑表叔表甥婿'],
		// 姑表姑表
		'f,f,xs,d':['姑表姑母','表姑妈','表姑母','表姑姑','表姑'],
		'f,f,xs,d,h':['姑表姑父','表姑爸','表姑父','表姑丈'],
		'f,f,xs,d,s&o':['堂姑表表兄','姑表姑表兄'],
		'f,f,xs,d,s&o,w':['堂姑表表嫂','姑表姑表嫂'],
		'f,f,xs,d,s&l':['堂姑表表弟','姑表姑表弟'],
		'f,f,xs,d,s&l,w':['堂姑表表弟媳'],
		'f,f,xs,d,s,s':['堂姑表表弟媳','姑表姑表侄男'],
		'f,f,xs,d,s,s,w':['堂姑表表侄妇','姑表姑表侄妇'],
		'f,f,xs,d,s,d':['堂姑表表侄女','姑表姑表侄女'],
		'f,f,xs,d,s,d,h':['堂姑表表侄婿','姑表姑表侄婿'],
		'f,f,xs,d,d&o':['堂姑表表姐','姑表姑表姐','姑表姑表姊'],
		'f,f,xs,d,d&o,h':['堂姑表表姐夫','姑表姑表姐夫','姑表姑表姊夫'],
		'f,f,xs,d,d&l':['堂姑表表妹','姑表姑表妹'],
		'f,f,xs,d,d&l,h':['堂姑表表妹夫','姑表姑表妹夫'],
		'f,f,xs,d,d,s':['堂姑表表甥男','姑表姑表甥男'],
		'f,f,xs,d,d,s,w':['堂姑表表甥妇','姑表姑表甥妇'],
		'f,f,xs,d,d,d':['堂姑表表甥女','姑表姑表甥女'],
		'f,f,xs,d,d,d,h':['堂姑表表甥婿','姑表姑表甥婿'],
		// 奶奶
		'f,m':['奶奶','祖母','阿嫲','阿嬷','嫲嫲'],
		'f,m,f':['曾外祖父','外太公','太姥爷'],
		'f,m,f,f':['曾外曾祖父','祖太爷','祖太爷爷','祖太公','高王父'],
		'f,m,f,m':['曾外曾祖母','祖太太','祖太奶奶','祖太婆','高王母'],
		// 从父*
		'f,m,f,ob':['伯曾外祖父','伯太姥爷','伯太奶爷'],
		'f,m,f,ob,w':['伯曾外祖母','伯太姥姥','伯太奶奶'],
		'f,m,f,lb':['叔曾外祖父','叔太姥爷','叔太奶爷'],
		'f,m,f,lb,w':['叔曾外祖母','叔太姥姥','叔太奶奶'],
		// 从父舅表
		'f,m,f,xb,s':['堂舅祖父','从父舅祖父'],
		'f,m,f,xb,s,w':['堂舅祖母','从父舅祖母'],
		'f,m,f,xb,s,s&o':['堂舅表伯父','从父舅表伯父'],
		'f,m,f,xb,s,s&o,w':['堂舅表伯母','从父舅表伯母'],
		'f,m,f,xb,s,s&l':['堂舅表叔父','从父舅表叔父'],
		'f,m,f,xb,s,s&l,w':['堂舅表叔母','从父舅表叔母'],
		'f,m,f,xb,s,d':['堂舅表姑母','从父舅表姑母'],
		'f,m,f,xb,s,d,h':['堂舅表姑父','从父舅表姑父'],
		// 从父姨表
		'f,m,f,xb,d':['堂姨祖母','从父姨祖母'],
		'f,m,f,xb,d,h':['堂姨祖父','从父姨祖父'],
		'f,m,f,xb,d,s&o':['堂姨表伯父','从父姨表伯父'],
		'f,m,f,xb,d,s&o,w':['堂姨表伯母','从父姨表伯母'],
		'f,m,f,xb,d,s&l':['堂姨表叔父','从父姨表叔父'],
		'f,m,f,xb,d,s&l,w':['堂姨表叔母','从父姨表叔母'],
		'f,m,f,xb,d,d':['堂姨表姑母','从父姨表姑母'],
		'f,m,f,xb,d,d,h':['堂姨表姑父','从父姨表姑父'],
		// 姑表*
		'f,m,f,xs':['姑曾外祖母','姑太姥姥','姑太奶奶'],
		'f,m,f,xs,h':['姑曾外祖父','姑太姥爷','姑太奶爷','姑太爷爷'],
		// 姑表舅表
		'f,m,f,xs,s':['姑表舅祖父'],
		'f,m,f,xs,s,w':['姑表舅祖母'],
		'f,m,f,xs,s,s&o':['姑表舅表伯父'],
		'f,m,f,xs,s,s&o,w':['姑表舅表伯母'],
		'f,m,f,xs,s,s&l':['姑表舅表叔父'],
		'f,m,f,xs,s,s&l,w':['姑表舅表叔母'],
		'f,m,f,xs,s,d':['姑表舅表姑母'],
		'f,m,f,xs,s,d,h':['姑表舅表姑父'],
		// 姑表姨表
		'f,m,f,xs,d':['姑表姨祖母'],
		'f,m,f,xs,d,h':['姑表姨祖父'],
		'f,m,f,xs,d,s&o':['姑表姨表伯父'],
		'f,m,f,xs,d,s&o,w':['姑表姨表伯母'],
		'f,m,f,xs,d,s&l':['姑表姨表叔父'],
		'f,m,f,xs,d,s&l,w':['姑表姨表叔母'],
		'f,m,f,xs,d,d':['姑表姨表姑母'],
		'f,m,f,xs,d,d,h':['姑表姨表姑父'],
		'f,m,m':['曾外祖母','外太婆','太姥姥'],
		'f,m,m,f':['曾外曾外祖父','祖太姥爷','祖太公','高王父'],
		'f,m,m,m':['曾外曾外祖母','祖太姥姥','祖太姥娘','祖太婆','高王母'],
		// 舅表*
		'f,m,m,xb':['舅曾外祖父','舅太姥爷','舅太奶爷'],
		'f,m,m,xb,w':['舅曾外祖母','舅太姥姥','舅太奶奶'],
		// 舅表舅表
		'f,m,m,xb,s':['舅表舅祖父'],
		'f,m,m,xb,s,w':['舅表舅祖母'],
		'f,m,m,xb,s,s&o':['舅表舅表伯父'],
		'f,m,m,xb,s,s&o,w':['舅表舅表伯母'],
		'f,m,m,xb,s,s&l':['舅表舅表叔父'],
		'f,m,m,xb,s,s&l,w':['舅表舅表叔母'],
		'f,m,m,xb,s,d':['舅表舅表姑母'],
		'f,m,m,xb,s,d,h':['舅表舅表姑父'],
		// 舅表姨表
		'f,m,m,xb,d':['舅表姨祖母'],
		'f,m,m,xb,d,h':['舅表姨祖父'],
		'f,m,m,xb,d,s&o':['舅表姨表伯父'],
		'f,m,m,xb,d,s&o,w':['舅表姨表伯母'],
		'f,m,m,xb,d,s&l':['舅表姨表叔父'],
		'f,m,m,xb,d,s&l,w':['舅表姨表叔母'],
		'f,m,m,xb,d,d':['舅表姨表姑母'],
		'f,m,m,xb,d,d,h':['舅表姨表姑父'],
		// 从母*
		'f,m,m,xs':['姨曾外祖母','姨太姥姥','姨太奶奶'],
		'f,m,m,xs,h':['姨曾外祖父','姨太姥爷','姨太奶爷'],
		// 从母舅表
		'f,m,m,xs,s':['从母舅祖父'],
		'f,m,m,xs,s,w':['从母舅祖母'],
		'f,m,m,xs,s,s&o':['从母舅表伯父'],
		'f,m,m,xs,s,s&o,w':['从母舅表伯母'],
		'f,m,m,xs,s,s&l':['从母舅表叔父'],
		'f,m,m,xs,s,s&l,w':['从母舅表叔父'],
		'f,m,m,xs,s,d':['从母舅表姑母'],
		'f,m,m,xs,s,d,h':['从母舅表姑父'],
		// 从母姨表
		'f,m,m,xs,d':['从母姨祖母'],
		'f,m,m,xs,d,h':['从母姨祖父'],
		'f,m,m,xs,d,s&o':['再从母伯父'],
		'f,m,m,xs,d,s&o,w':['再从母伯母'],
		'f,m,m,xs,d,s&l':['再从母叔父'],
		'f,m,m,xs,d,s&l,w':['再从母叔母'],
		'f,m,m,xs,d,d':['再从母姑母'],
		'f,m,m,xs,d,d,h':['再从母姑父'],
		// 舅表*
		'f,m,xb':['舅公','舅祖父','舅老爷','舅爷爷','舅爷','舅祖','舅奶爷','太舅父','x舅老爷','x舅公'],
		'f,m,xb,w':['舅婆','舅祖母','舅奶奶','舅奶','妗婆','太舅母'],
		// 舅表叔表
		'f,m,xb,s&o':['舅表伯父','表伯父','表伯'],
		'f,m,xb,s&o,w':['舅表伯母','表伯母'],
		'f,m,xb,s&l':['舅表叔父','表叔父','表叔爸','表叔'],
		'f,m,xb,s&l,w':['舅表叔母','表叔母','表叔妈','表婶'],
		'f,m,xb,s':['舅祖父'],
		'f,m,xb,s,w':['舅祖母'],
		'f,m,xb,s,s&o':['舅表叔表兄'],
		'f,m,xb,s,s&l':['舅表叔表弟'],
		'f,m,xb,s,s,s':['舅表叔表侄男'],
		'f,m,xb,s,s,s,w':['舅表叔表侄妇'],
		'f,m,xb,s,s,d':['舅表叔表侄女'],
		'f,m,xb,s,s,d,h':['舅表叔表侄婿'],
		'f,m,xb,s,d&o':['舅表叔表姊'],
		'f,m,xb,s,d&l':['舅表叔表妹'],
		'f,m,xb,s,d,s':['舅表叔表甥男'],
		'f,m,xb,s,d,s,w':['舅表叔表甥妇'],
		'f,m,xb,s,d,d':['舅表叔表甥女'],
		'f,m,xb,s,d,d,h':['舅表叔表甥婿'],
		// 舅表姑表
		'f,m,xb,d':['舅表姑母','表姑妈','表姑母','表姑姑','表姑'],
		'f,m,xb,d,h':['舅表姑父','表姑爸','表姑父','表姑丈'],
		'f,m,xb,d,s&o':['舅表姑表兄'],
		'f,m,xb,d,s&l':['舅表姑表弟'],
		'f,m,xb,d,s,s':['舅表姑表侄男'],
		'f,m,xb,d,s,s,w':['舅表姑表侄妇'],
		'f,m,xb,d,s,d':['舅表姑表侄女'],
		'f,m,xb,d,s,d,h':['舅表姑表侄婿'],
		'f,m,xb,d,d&o':['舅表姑表姊'],
		'f,m,xb,d,d&l':['舅表姑表妹'],
		'f,m,xb,d,d,s':['舅表姑表甥男'],
		'f,m,xb,d,d,s,w':['舅表姑表甥妇'],
		'f,m,xb,d,d,d':['舅表姑表甥女'],
		'f,m,xb,d,d,d,h':['舅表姑表甥婿'],
		// 从母*
		'f,m,xs':['姨奶奶','祖姨母','姨祖母','姨婆','姨奶','x姨奶'],
		'f,m,xs,h':['姨爷爷','祖姨父','姨祖父','姨公','姨丈公','姨爷','姨老爷','姨奶爷'],
		// 从母叔表
		'f,m,xs,s&o':['姨伯父','姨伯','从母伯父'],
		'f,m,xs,s&o,w':['姨伯母','从母伯母'],
		'f,m,xs,s&l':['姨叔父','姨叔','从母叔父'],
		'f,m,xs,s&l,w':['姨叔母','从母叔母'],
		'f,m,xs,s,s&o':['从母叔表兄'],
		'f,m,xs,s,s&l':['从母叔表弟'],
		'f,m,xs,s,s,s':['从母叔表侄男'],
		'f,m,xs,s,s,s,w':['从母叔表侄妇'],
		'f,m,xs,s,s,d':['从母叔表侄女'],
		'f,m,xs,s,s,d,h':['从母叔表侄婿'],
		'f,m,xs,s,d&o':['从母叔表姊'],
		'f,m,xs,s,d&l':['从母叔表妹'],
		'f,m,xs,s,d,s':['从母叔表甥男'],
		'f,m,xs,s,d,s,w':['从母叔表甥妇'],
		'f,m,xs,s,d,d':['从母叔表甥女'],
		'f,m,xs,s,d,d,h':['从母叔表甥婿'],
		// 从母姑表
		'f,m,xs,d':['姨姑母','姨姑','从母姑母'],
		'f,m,xs,d,h':['姨姑父','从母姑父','从母姑丈'],
		'f,m,xs,d,s&o':['从母姑表兄'],
		'f,m,xs,d,s&l':['从母姑表弟'],
		'f,m,xs,d,s,s':['从母姑表侄男'],
		'f,m,xs,d,s,s,w':['从母姑表侄妇'],
		'f,m,xs,d,s,d':['从母姑表侄女'],
		'f,m,xs,d,s,d,h':['从母姑表侄婿'],
		'f,m,xs,d,d&o':['从母姑表姊'],
		'f,m,xs,d,d&l':['从母姑表妹'],
		'f,m,xs,d,d,s':['从母姑表甥男'],
		'f,m,xs,d,d,s,w':['从母姑表甥妇'],
		'f,m,xs,d,d,d':['从母姑表甥女'],
		'f,m,xs,d,d,d,h':['从母姑表甥婿'],
		// 从父
		'f,ob':['伯父','伯伯','阿伯','大伯','大爹','大爸','x伯'],
		'f,ob,w':['伯母','伯妈','伯娘','大娘','大妈','x妈'],
		'f,lb':['叔叔','叔父','阿叔','叔爸','叔爹','仲父','小爹','小爸','幺爸','x叔','叔'],
		'f,lb,w':['婶婶','婶母','婶娘','婶爹','婶妈','婶子','家婶','叔母','阿婶','叔妈','叔娘','季母','小娘','小妈','幺婶','x婶','婶'],
		'f,xb,w,f':['叔姻外祖父','叔眷毑父','眷爷爷'],
		'f,xb,w,m':['叔姻外祖母','叔眷毑母','眷姥姥'],
		'f,xb,w,xb':['叔姻舅父','姻舅父'],
		'f,xb,w,xb,w':['叔姻舅母','姻舅母'],
		'f,xb,w,xs':['叔姻姨母','姻姨母'],
		'f,xb,w,xs,h':['叔姻姨父','姻姨父'],
		'f,xb,s&o':['堂哥','堂兄','堂阿哥','从父兄','叔伯兄','从兄'],
		'f,xb,s&o,w':['堂嫂','从父兄妇','叔伯兄妇'],
		'f,xb,s&l':['堂弟','堂阿弟','从父弟','叔伯弟','从弟'],
		'f,xb,s&l,w':['堂弟媳','堂弟妹','从父弟妇','叔伯弟妇'],
		'f,xb,s,s':['堂侄','堂侄男','堂侄子','从父侄男','叔伯侄男'],
		'f,xb,s,s,w':['堂侄媳妇','堂侄妇','从父侄妇','叔伯侄父'],
		'f,xb,s,s,s':['堂侄孙'],
		'f,xb,s,s,s,w':['堂侄孙媳'],
		'f,xb,s,s,d':['堂侄孙女'],
		'f,xb,s,s,d,h':['堂侄孙女婿'],
		'f,xb,s,d':['堂侄女','从父侄女','叔伯侄女','堂侄'],
		'f,xb,s,d,h':['堂侄女婿','堂侄婿','从父侄婿','叔伯侄婿'],
		'f,xb,s,d,s':['堂侄外孙'],
		'f,xb,s,d,s,w':['堂侄外孙媳'],
		'f,xb,s,d,d':['堂侄外孙女'],
		'f,xb,s,d,d,h':['堂侄外孙女婿'],
		'f,xb,d&o':['堂姐','堂姊','堂阿姐','从父姊','叔伯姊','从姊'],
		'f,xb,d&o,h':['堂姐夫','从父姊夫','从父姊婿','叔伯姊夫'],
		'f,xb,d&l':['堂妹','堂阿妹','从父妹','叔伯妹','从妹'],
		'f,xb,d&l,h':['堂妹夫','从父妹夫','从父妹婿','叔伯妹夫'],
		'f,xb,d,s':['堂外甥','堂甥'],
		'f,xb,d,s,w':['堂甥媳'],
		'f,xb,d,s,s':['堂甥孙'],
		'f,xb,d,s,s,w':['堂甥孙媳'],
		'f,xb,d,s,d':['堂甥孙女'],
		'f,xb,d,s,d,h':['堂甥孙女婿'],
		'f,xb,d,d':['堂外甥女'],
		'f,xb,d,d,h':['堂外甥女婿'],
		'f,xb,d,d,s':['堂甥外孙'],
		'f,xb,d,d,s,w':['堂甥外孙媳'],
		'f,xb,d,d,d':['堂甥外孙女'],
		'f,xb,d,d,d,h':['堂甥外孙女婿'],
		// 姑表
		'f,os':['姑妈','姑母'],
		'f,ls':['姑妈','姑姐'],
		'f,xs':['姑妈','姑姑','姑娘','大姑妈','姑','x姑妈'],
		'f,xs,h':['姑丈','姑父','姑爸','姑夫','x姑丈','x姑父'],
		'f,xs,h,f':['姑姻祖父','姻爷爷'],
		'f,xs,h,m':['姑姻祖母','姻奶奶'],
		'f,xs,h,ob':['姑姻伯父','姻伯父','姻世伯'],
		'f,xs,h,ob,w':['姑姻伯母','姻伯母'],
		'f,xs,h,lb':['姑姻叔父','姻叔父'],
		'f,xs,h,lb,w':['姑姻叔母','姻叔母'],
		'f,xs,h,xs':['姑姻姑母','姻姑母'],
		'f,xs,h,xs,h':['姑姻姑父','姻姑父'],
		'f,xs,s&o':['姑表哥','姑表兄','表哥','表兄'],
		'f,xs,s&o,w':['姑表嫂','姑表兄妇','表嫂'],
		'f,xs,s&l':['姑表弟','表弟'],
		'f,xs,s&l,w':['姑表弟妇','姑表弟妇','表弟妇','表弟妹'],
		'f,xs,s,s':['姑表侄男','表侄男','表侄'],
		'f,xs,s,s,w':['姑表侄妇','表侄妇'],
		'f,xs,s,s,s':['姑表侄孙男','姑表侄孙','表侄孙'],
		'f,xs,s,s,s,w':['姑表侄孙妇','表侄孙妇'],
		'f,xs,s,s,d':['姑表侄孙女','表侄孙女'],
		'f,xs,s,s,d,h':['姑表侄孙婿','表侄孙婿'],
		'f,xs,s,d':['姑表侄女','表侄女','表侄'],
		'f,xs,s,d,h':['姑表侄婿','表侄婿'],
		'f,xs,s,d,s':['姑表侄外孙男'],
		'f,xs,s,d,s,w':['姑表侄外孙妇'],
		'f,xs,s,d,d':['姑表侄外孙女'],
		'f,xs,s,d,d,h':['姑表侄外孙婿'],
		'f,xs,d&o':['姑表姐','姑表姊','表姐','表姊'],
		'f,xs,d&o,h':['姑表姐夫','姑表姊夫','姑表姊婿','表姐夫','表姊夫','表姐丈','表姊丈'],
		'f,xs,d&l':['姑表妹','表妹'],
		'f,xs,d&l,h':['姑表妹夫','姑表妹婿','表妹夫'],
		'f,xs,d,s':['姑表甥男','表甥男','表外甥'],
		'f,xs,d,s,w':['姑表甥妇'],
		'f,xs,d,s,s':['姑表甥孙男','表甥孙男'],
		'f,xs,d,s,s,w':['姑表甥孙妇','表甥孙妇'],
		'f,xs,d,s,d':['姑表甥孙女','表甥孙女'],
		'f,xs,d,s,d,h':['姑表甥孙婿','表甥孙婿'],
		'f,xs,d,d':['姑表甥女','表甥女','表外甥'],
		'f,xs,d,d,h':['姑表甥婿'],
		'f,xs,d,d,s':['姑表甥外孙男','表甥外孙男'],
		'f,xs,d,d,s,w':['姑表甥外孙妇','表甥外孙妇'],
		'f,xs,d,d,d':['姑表甥外孙女','表甥外孙女'],
		'f,xs,d,d,d,h':['姑表甥外孙婿','表甥外孙婿'],
		// 外家
		'm':['妈妈','母亲','老妈','阿妈','老母','老妈子','妈','母','娘','娘亲','妈咪'],
		// 外公
		'm,f':['外公','姥爷','外祖父','外王父','阿公','毑父'],
		'm,f,f':['外曾祖父','曾外祖父','外太祖父','外曾王父','外太公','外太爷爷','太外祖父'],
		'm,f,f,f':['外高祖父','高外祖父','祖太爷','祖太爷爷','祖太公','高王父'],
		'm,f,f,m':['外高祖母','高外祖母','祖太太','祖太奶奶','祖太婆','高王母'],
		// 从父*
		'm,f,f,ob':['伯外曾祖父','外太伯公','伯太姥爷','伯太奶爷','伯太爷爷'],
		'm,f,f,ob,w':['伯外曾祖母','外太伯母','伯太姥姥','伯太奶奶'],
		'm,f,f,lb':['叔外曾祖父','外太叔公','叔太姥爷','叔太奶爷','叔太爷爷'],
		'm,f,f,lb,w':['叔外曾祖母','外太叔母','叔太姥姥','叔太奶奶'],
		// 再从父
		'm,f,f,xb,s':['堂外祖父','从父外祖父','从父姥爷'],
		'm,f,f,xb,s,w':['堂外祖母','从父外祖母','从父姥姥'],
		'm,f,f,xb,s&o':['堂伯外祖父','从父伯外祖父','从父伯姥爷'],
		'm,f,f,xb,s&o,w':['堂伯外祖母','从父伯外祖母','从父伯姥姥'],
		'm,f,f,xb,s&l':['堂叔外祖父','从父叔外祖父','从父叔姥爷'],
		'm,f,f,xb,s&l,w':['堂叔外祖母','从父叔外祖母','从父叔姥姥'],
		'm,f,f,xb,s,s':['再从父舅父'],
		'm,f,f,xb,s,s,w':['再从父舅母'],
		'm,f,f,xb,s,d':['再从父姨母'],
		'm,f,f,xb,s,d,h':['再从父姨父'],
		// 从父姑表
		'm,f,f,xb,d':['堂姑外祖母','从父姑外祖母'],
		'm,f,f,xb,d,h':['堂姑外祖父','从父姑外祖父'],
		'm,f,f,xb,d,s':['堂姑表舅父','从父姑表舅父'],
		'm,f,f,xb,d,s,w':['堂姑表舅母','从父姑表舅母'],
		'm,f,f,xb,d,d':['堂姑表姨母','从父姑表姨母'],
		'm,f,f,xb,d,d,h':['堂姑表姨父','从父姑表姨父'],
		// 姑表*
		'm,f,f,xs':['姑外曾祖母','外太姑婆','姑太姥姥','姑太奶奶'],
		'm,f,f,xs,h':['姑外曾祖父','外太姑丈公','姑太姥爷','姑太奶爷','姑太爷爷'],
		// 姑表叔表
		'm,f,f,xs,s&o':['姑表伯外祖父',],
		'm,f,f,xs,s&o,w':['姑表伯外祖母'],
		'm,f,f,xs,s&l':['姑表叔外祖父'],
		'm,f,f,xs,s&l,w':['姑表叔外祖母'],
		'm,f,f,xs,s,s':['姑表叔表舅父'],
		'm,f,f,xs,s,s,w':['姑表叔表舅母'],
		'm,f,f,xs,s,d':['姑表叔表姨母'],
		'm,f,f,xs,s,d,h':['姑表叔表姨父'],
		// 姑表姑表
		'm,f,f,xs,d':['姑表姑外祖母'],
		'm,f,f,xs,d,h':['姑表姑外祖父'],
		'm,f,f,xs,d,s':['姑表姑表舅父'],
		'm,f,f,xs,d,s,w':['姑表姑表舅母'],
		'm,f,f,xs,d,d':['姑表姑表姨母'],
		'm,f,f,xs,d,d,h':['姑表姑表姨父'],
		'm,f,m':['外曾祖母','外太祖母','外曾王母','太外祖母','外太奶奶','外太婆'],
		'm,f,m,f':['外高外祖父','祖太姥爷','祖太公','高王父'],
		'm,f,m,m':['外高外祖母','祖太姥姥','祖太姥娘','祖太婆','高王母'],
		// 舅表*
		'm,f,m,xb':['舅外曾祖父','外曾舅祖父','外太舅公','舅太姥爷','舅太奶爷'],
		'm,f,m,xb,w':['舅外曾祖母','外曾舅祖母','外太舅母','舅太姥姥','舅太奶奶','外太舅婆'],
		// 舅表叔表
		'm,f,m,xb,s&o':['舅表伯外祖父'],
		'm,f,m,xb,s&o,w':['舅表伯外祖母'],
		'm,f,m,xb,s&l':['舅表叔外祖父'],
		'm,f,m,xb,s&l,w':['舅表叔外祖母'],
		'm,f,m,xb,s,s':['舅表叔表舅父'],
		'm,f,m,xb,s,s,w':['舅表叔表舅母'],
		'm,f,m,xb,s,d':['舅表叔表姨母'],
		'm,f,m,xb,s,d,h':['舅表叔表姨父'],
		// 舅表姑表
		'm,f,m,xb,d':['舅表姑外祖母'],
		'm,f,m,xb,d,h':['舅表姑外祖父'],
		'm,f,m,xb,d,s':['舅表姑表舅父'],
		'm,f,m,xb,d,s,w':['舅表姑表舅母'],
		'm,f,m,xb,d,d':['舅表姑表姨母'],
		'm,f,m,xb,d,d,h':['舅表姑表姨父'],
		// 从母*
		'm,f,m,xs':['姨外曾祖母','外曾姨祖母','外太姨婆','姨太姥姥','姨太奶奶'],
		'm,f,m,xs,h':['姨外曾祖父','外曾姨祖父','外太姑姨公','姨太姥爷','姨太奶爷','姨太爷爷'],
		// 从母叔表
		'm,f,m,xs,s&o':['从母伯外祖父'],
		'm,f,m,xs,s&o,w':['从母伯外祖母'],
		'm,f,m,xs,s&l':['从母叔外祖父'],
		'm,f,m,xs,s&l,w':['从母叔外祖父'],
		'm,f,m,xs,s,s':['从母叔表舅父'],
		'm,f,m,xs,s,s,w':['从母叔表舅母'],
		'm,f,m,xs,s,d':['从母叔表姨母'],
		'm,f,m,xs,s,d,h':['从母叔表姨父'],
		// 从母姑表
		'm,f,m,xs,d':['从母姑外祖母'],
		'm,f,m,xs,d,h':['从母姑外祖父'],
		'm,f,m,xs,d,s':['从母姑表舅父'],
		'm,f,m,xs,d,s,w':['从母姑表舅母'],
		'm,f,m,xs,d,d':['从母姑表姨母'],
		'm,f,m,xs,d,d,h':['从母姑表姨父'],
		// 从父*
		'm,f,ob':['外伯公','伯外祖父','外伯祖父','伯姥爷','外伯祖','大外公','大姥爷','x外公','x姥爷'],
		'm,f,ob,w':['外伯婆','伯外祖母','外伯祖母','伯姥姥','大姥姥','外姆婆','小外公','小姥爷','x外公','x姥爷'],
		'm,f,lb':['外叔公','叔外祖父','外叔祖父','叔姥爷','外叔祖','叔外祖'],
		'm,f,lb,w':['外叔婆','叔外祖母','外叔祖母','叔姥姥','小姥姥','外姆婆'],
		// 从父舅表
		'm,f,xb,s':['堂舅','堂舅爸','堂舅父','堂舅舅','从父舅父','叔伯舅父','叔伯舅'],
		'm,f,xb,s,w':['堂舅妈','堂舅母','从父舅母','叔伯舅母'],
		'm,f,xb,s,s&o':['堂舅表兄','从父舅表兄'],
		'm,f,xb,s,s&l':['堂舅表弟','从父舅表弟'],
		'm,f,xb,s,s,s':['堂舅表侄男','从父舅表侄男'],
		'm,f,xb,s,s,s,w':['堂舅表侄妇','从父舅表侄妇'],
		'm,f,xb,s,s,d':['堂舅表侄女','从父舅表侄女'],
		'm,f,xb,s,s,d,h':['堂舅表侄婿','从父舅表侄婿'],
		'm,f,xb,s,d&o':['堂舅表姊','从父舅表姊'],
		'm,f,xb,s,d&l':['堂舅表妹','从父舅表妹'],
		'm,f,xb,s,d,s':['堂舅表甥男','从父舅表甥男'],
		'm,f,xb,s,d,s,w':['堂舅表甥妇','从父舅表甥妇'],
		'm,f,xb,s,d,d':['堂舅表甥女','从父舅表甥女'],
		'm,f,xb,s,d,d,h':['堂舅表甥婿','从父舅表甥婿'],
		// 从父姨表
		'm,f,xb,d':['堂姨','堂姨妈','堂姨母','从父姨母','叔伯姨母','叔伯姨'],
		'm,f,xb,d,h':['堂姨丈','堂姨爸','堂姨父','从父姨父','叔伯姨父'],
		'm,f,xb,d,s&o':['堂父姨表兄','从父姨表兄'],
		'm,f,xb,d,s&l':['堂父姨表弟','从父姨表弟'],
		'm,f,xb,d,s,s':['堂父姨表侄男','从父姨表侄男'],
		'm,f,xb,d,s,s,w':['堂父姨表侄妇','从父姨表侄妇'],
		'm,f,xb,d,s,d':['堂姨表侄女','从父姨表侄女'],
		'm,f,xb,d,s,d,h':['堂父姨表侄婿','从父姨表侄婿'],
		'm,f,xb,d,d&o':['堂姨表姊','从父姨表姊'],
		'm,f,xb,d,d&l':['堂姨表妹','从父姨表妹'],
		'm,f,xb,d,d,s':['堂舅表甥男','从父舅表甥男'],
		'm,f,xb,d,d,s,w':['堂舅表甥妇','从父舅表甥妇'],
		'm,f,xb,d,d,d':['堂舅表甥女','从父舅表甥女'],
		'm,f,xb,d,d,d,h':['堂舅表甥婿','从父舅表甥婿'],
		// 姑表*
		'm,f,xs':['外姑婆','姑姥姥','姑外祖母','外姑祖母','外太姑母','外姑母'],
		'm,f,xs,h':['外姑公','姑姥爷','姑外祖父','外姑祖父','外太姑父','外姑丈'],
		// 姑表舅表
		'm,f,xs,s':['姑表舅父','姑表舅爸','表舅父','表舅爸','表舅','表舅舅','姑表舅舅'],
		'm,f,xs,s,w':['姑表舅母','姑表舅妈','表舅母','表舅妈'],
		'm,f,xs,s,s&o':['姑表舅表兄'],
		'm,f,xs,s,s&l':['姑表舅表弟'],
		'm,f,xs,s,s,s':['姑表舅表侄男'],
		'm,f,xs,s,s,s,w':['姑表舅表侄妇'],
		'm,f,xs,s,s,d':['姑表舅表侄女'],
		'm,f,xs,s,s,d,h':['姑表舅表侄婿'],
		'm,f,xs,s,d&o':['姑表舅表姊'],
		'm,f,xs,s,d&l':['姑表舅表妹'],
		'm,f,xs,s,d,s':['姑表舅表甥男'],
		'm,f,xs,s,d,s,w':['姑表舅表甥妇'],
		'm,f,xs,s,d,d':['姑表舅表甥女'],
		'm,f,xs,s,d,d,h':['姑表舅表甥婿'],
		// 姑表姨表
		'm,f,xs,d':['姑表姨母','姑表姨妈','表姨母','表姨妈','表姨','表阿姨','姑表姨姨'],
		'm,f,xs,d,h':['姑表姨父','姑表姨父','表姨丈','表姨父'],
		'm,f,xs,d,s&o':['姑表姨表兄'],
		'm,f,xs,d,s&l':['姑表姨表弟'],
		'm,f,xs,d,s,s':['姑表姨表侄男'],
		'm,f,xs,d,s,s,w':['姑表姨表侄妇'],
		'm,f,xs,d,s,d':['姑表姨表侄女'],
		'm,f,xs,d,s,d,h':['姑表姨表侄婿'],
		'm,f,xs,d,d&o':['姑表姨表姊'],
		'm,f,xs,d,d&l':['姑表姨表妹'],
		'm,f,xs,d,d,s':['姑表姨表甥男'],
		'm,f,xs,d,d,s,w':['姑表姨表甥妇'],
		'm,f,xs,d,d,d':['姑表姨表甥女'],
		'm,f,xs,d,d,d,h':['姑表姨表甥婿'],
		// 外婆
		'm,m':['外婆','外祖母','外王母','姥姥','阿婆','毑母'],
		'm,m,f':['外曾外祖父','外太外公','外太姥爷'],
		'm,m,f,f':['外曾外曾祖父','祖太爷','祖太爷爷','祖太公','高王父'],
		'm,m,f,m':['外曾外曾祖母','祖太太','祖太奶奶','祖太婆','高王母'],
		// 从父*
		'm,m,f,ob':['伯外曾外祖父','伯太姥爷'],
		'm,m,f,ob,w':['伯外曾外祖母','伯太姥姥'],
		'm,m,f,lb':['叔外曾外祖父','叔太姥爷'],
		'm,m,f,lb,w':['叔外曾外祖母','叔太姥姥'],
		// 从父舅表
		'm,m,f,xb,s':['堂舅外祖父','从父舅外祖父'],
		'm,m,f,xb,s,w':['堂舅外祖母','从父舅外祖母'],
		'm,m,f,xb,s,s':['堂舅表舅父','从父舅表舅父'],
		'm,m,f,xb,s,s,w':['堂舅表舅母','从父舅表舅母'],
		'm,m,f,xb,s,d':['堂舅表姨母','从父舅表姨母'],
		'm,m,f,xb,s,d,h':['堂舅表姨父','从父舅表姨父'],
		// 从父姨表
		'm,m,f,xb,d':['堂姨外祖母','从父姨外祖母'],
		'm,m,f,xb,d,h':['堂姨外祖父','从父姨外祖父'],
		'm,m,f,xb,d,s':['堂姨表舅父','从父姨表舅父'],
		'm,m,f,xb,d,s,w':['堂姨表舅母','从父姨表舅母'],
		'm,m,f,xb,d,d':['堂姨表姨母','从父姨表姨母'],
		'm,m,f,xb,d,d,h':['堂姨表姨父','从父姨表姨父'],
		// 姑表*
		'm,m,f,xs':['姑外曾外祖母','姑太姥姥'],
		'm,m,f,xs,h':['姑外曾外祖父','姑太姥爷'],
		// 姑表舅表
		'm,m,f,xs,s':['姑表舅外祖父'],
		'm,m,f,xs,s,w':['姑表舅外祖母'],
		'm,m,f,xs,s,s':['姑表舅表舅父'],
		'm,m,f,xs,s,s,w':['姑表舅表舅母'],
		'm,m,f,xs,s,d':['姑表舅表姨母'],
		'm,m,f,xs,s,d,h':['姑表舅表姨父'],
		// 姑表姨表
		'm,m,f,xs,d':['姑表姨外祖母'],
		'm,m,f,xs,d,h':['姑表姨外祖父'],
		'm,m,f,xs,d,s':['姑表姨表舅父'],
		'm,m,f,xs,d,s,w':['姑表姨表舅母'],
		'm,m,f,xs,d,d':['姑表姨表姨母'],
		'm,m,f,xs,d,d,h':['姑表姨表姨父'],
		'm,m,m':['外曾外祖母','外太外婆','外太姥姥'],
		'm,m,m,f':['外曾外曾外祖父','祖太姥爷','祖太公','高王父'],
		'm,m,m,m':['外曾外曾外祖母','祖太姥姥','祖太姥娘','祖太婆','高王母'],
		// 舅表*
		'm,m,m,xb':['舅外曾外祖父','舅太姥爷'],
		'm,m,m,xb,w':['舅外曾外祖母','舅太姥姥'],
		// 舅表舅表
		'm,m,m,xb,s':['舅表舅外祖父'],
		'm,m,m,xb,s,w':['舅表舅外祖母'],
		'm,m,m,xb,s,s':['舅表舅表舅父'],
		'm,m,m,xb,s,s,w':['舅表舅表舅母'],
		'm,m,m,xb,s,d':['舅表舅表姨母'],
		'm,m,m,xb,s,d,h':['舅表舅表姨父'],
		// 舅表姨表
		'm,m,m,xb,d':['舅表姨外祖母'],
		'm,m,m,xb,d,h':['舅表姨外祖父'],
		'm,m,m,xb,d,s':['舅表姨表舅父'],
		'm,m,m,xb,d,s,w':['舅表姨表舅母'],
		'm,m,m,xb,d,d':['舅表姨表姨母'],
		'm,m,m,xb,d,d,h':['舅表姨表姨父'],
		// 从母*
		'm,m,m,xs':['姨外曾外祖母','姨太姥姥'],
		'm,m,m,xs,h':['姨外曾外祖父','姨太姥爷'],
		// 从母舅表
		'm,m,m,xs,s':['从母舅外祖父'],
		'm,m,m,xs,s,w':['从母舅外祖母'],
		'm,m,m,xs,s,s':['从母舅表舅父'],
		'm,m,m,xs,s,s,w':['从母舅表舅母'],
		'm,m,m,xs,s,d':['从母舅表姨母'],
		'm,m,m,xs,s,d,h':['从母舅表姨父'],
		// 再从母
		'm,m,m,xs,d':['从母姨外祖母','从母姨姥姥'],
		'm,m,m,xs,d,h':['从母姨外祖父','从母姨姥爷'],
		'm,m,m,xs,d,s':['再从母舅父'],
		'm,m,m,xs,d,s,w':['再从母舅母'],
		'm,m,m,xs,d,d':['再从母姨母'],
		'm,m,m,xs,d,d,h':['再从母姨父'],
		'm,m,m,xs,d,d,s&o':['三从母兄'],
		'm,m,m,xs,d,d,s&l':['三从母弟'],
		'm,m,m,xs,d,d,d&o':['三从母姊'],
		'm,m,m,xs,d,d,d&l':['三从母妹'],
		// 舅表*
		'm,m,xb':['外舅公','外舅祖父','外太舅父','舅外祖父','舅姥爷','舅外公','舅公','x舅姥爷'],
		'm,m,xb,w':['外舅婆','外舅祖母','外太舅母','舅外祖母','舅姥姥','舅婆','外妗婆'],
		// 舅表舅表
		'm,m,xb,s':['舅表舅父','舅表舅爸','表舅父','表舅爸','表舅','表舅舅','舅表舅舅'],
		'm,m,xb,s,w':['舅表舅母','舅表舅妈','表舅母','表舅妈'],
		'm,m,xb,s,s&o':['舅表舅表兄'],
		'm,m,xb,s,s&l':['舅表舅表弟'],
		'm,m,xb,s,s,s':['舅表舅表侄男'],
		'm,m,xb,s,s,s,w':['舅表舅表侄妇'],
		'm,m,xb,s,s,d':['舅表舅表侄女'],
		'm,m,xb,s,s,d,h':['舅表舅表侄婿'],
		'm,m,xb,s,d&o':['舅表舅表姊'],
		'm,m,xb,s,d&l':['舅表舅表妹'],
		'm,m,xb,s,d,s':['舅表舅表甥男'],
		'm,m,xb,s,d,s,w':['舅表舅表甥妇'],
		'm,m,xb,s,d,d':['舅表舅表甥女'],
		'm,m,xb,s,d,d,h':['舅表舅表甥婿'],
		// 舅表姨表
		'm,m,xb,d':['舅表姨母','舅表姨妈','表姨母','表姨妈','表姨','表阿姨','舅表姨姨'],
		'm,m,xb,d,h':['舅表姨父','舅表姨丈','表姨父','表姨丈'],
		'm,m,xb,d,s&o':['舅表姨表兄'],
		'm,m,xb,d,s&l':['舅表姨表弟'],
		'm,m,xb,d,s,s':['舅表姨表侄男'],
		'm,m,xb,d,s,s,w':['舅表姨表侄妇'],
		'm,m,xb,d,s,d':['舅表姨表侄女'],
		'm,m,xb,d,s,d,h':['舅表姨表侄婿'],
		'm,m,xb,d,d&o':['舅表姨表姊'],
		'm,m,xb,d,d&l':['舅表姨表妹'],
		'm,m,xb,d,d,s':['舅表姨表甥男'],
		'm,m,xb,d,d,s,w':['舅表姨表甥妇'],
		'm,m,xb,d,d,d':['舅表姨表甥女'],
		'm,m,xb,d,d,d,h':['舅表姨表甥婿'],
		// 从母*
		'm,m,xs':['外姨婆','姨外祖母','姨姥姥','外姨祖母','从母姨外祖母'],
		'm,m,xs,h':['外姨公','姨外祖父','姨姥爷','外姨祖父','从母姨外祖父'],
		// 从母舅表
		'm,m,xs,s':['姨舅父','姨舅','从母舅父'],
		'm,m,xs,s,w':['姨舅母','从母舅母'],
		'm,m,xs,s,s&o':['从母舅表兄'],
		'm,m,xs,s,s&l':['从母舅表弟'],
		'm,m,xs,s,s,s':['从母舅表侄男'],
		'm,m,xs,s,s,s,w':['从母舅表侄妇'],
		'm,m,xs,s,s,d':['从母舅表侄女'],
		'm,m,xs,s,s,d,h':['从母舅表侄婿'],
		'm,m,xs,s,d&o':['从母舅表姊'],
		'm,m,xs,s,d&l':['从母舅表妹'],
		'm,m,xs,s,d,s':['从母舅表甥男'],
		'm,m,xs,s,d,s,w':['从母舅表甥妇'],
		'm,m,xs,s,d,d':['从母舅表甥女'],
		'm,m,xs,s,d,d,h':['从母舅表甥婿'],
		// 再从母
		'm,m,xs,d':['姨姨母','从母姨母'],
		'm,m,xs,d,h':['姨姨父','从母姨父','从母姨丈'],
		'm,m,xs,d,s&o':['再从母兄'],
		'm,m,xs,d,s&l':['再从母弟'],
		'm,m,xs,d,s,s':['再从母侄男'],
		'm,m,xs,d,s,s,w':['再从母侄妇'],
		'm,m,xs,d,s,d':['再从母侄女'],
		'm,m,xs,d,s,d,h':['再从母侄婿'],
		'm,m,xs,d,d&o':['再从母姊'],
		'm,m,xs,d,d&l':['再从母妹'],
		'm,m,xs,d,d,s':['再从母甥男'],
		'm,m,xs,d,d,s,w':['再从母甥妇'],
		'm,m,xs,d,d,d':['再从母甥女'],
		'm,m,xs,d,d,d,h':['再从母甥婿'],
		// 舅表
		'm,xb':['舅舅','舅父','舅','娘舅','舅仔','母舅','舅爸','舅爹','阿舅','x舅'],
		'm,xb,w':['舅妈','舅母','妗子','妗妗','妗妈','妗母','阿妗','x舅妈'],
		'm,xb,w,f':['舅姻外祖父','舅眷毑父','眷爷爷'],
		'm,xb,w,m':['舅姻外祖母','舅眷毑母','眷姥姥'],
		'm,xb,w,xb':['舅姻舅父','姻舅父'],
		'm,xb,w,xb,w':['舅姻舅母','姻舅母'],
		'm,xb,w,xs':['舅姻姨母','姻姨母'],
		'm,xb,w,xs,h':['舅姻姨父','姻姨父'],
		'm,xb,s&o':['舅表哥','舅表兄','表哥','表兄'],
		'm,xb,s&o,w':['舅表嫂','舅表兄妇','表嫂'],
		'm,xb,s&l':['舅表弟','表弟'],
		'm,xb,s&l,w':['舅表弟媳','舅表弟妇','表弟媳','表弟妹'],
		'm,xb,s,s':['舅表侄男','表侄男','表侄'],
		'm,xb,s,s,w':['舅表侄妇','表侄妇'],
		'm,xb,s,s,s':['舅表侄孙男','舅表侄孙','表侄孙'],
		'm,xb,s,s,s,w':['舅表侄孙妇','表侄孙妇'],
		'm,xb,s,s,d':['舅表侄孙女','表侄孙女'],
		'm,xb,s,s,d,h':['舅表侄孙婿','表侄孙婿'],
		'm,xb,s,d':['舅表侄女','表侄女','表侄'],
		'm,xb,s,d,h':['舅表侄婿','表侄婿'],	
		'm,xb,s,d,s':['舅表侄外孙男'],
		'm,xb,s,d,s,w':['舅表侄外孙妇'],
		'm,xb,s,d,d':['舅表侄外孙女'],
		'm,xb,s,d,d,h':['舅表侄外孙婿'],
		'm,xb,d&o':['舅表姐','舅表姊','表姐','表姊'],
		'm,xb,d&o,h':['舅表姐夫','舅表姊夫','舅表姊婿','表姐夫','表姐姊','表姐丈','表姊丈'],
		'm,xb,d&l':['舅表妹','表妹'],
		'm,xb,d&l,h':['舅表妹夫','舅表妹婿','表妹夫'],
		'm,xb,d,s':['舅表甥男','表外甥','表甥男'],
		'm,xb,d,s,w':['舅表甥妇'],
		'm,xb,d,s,s':['舅表甥孙男','表甥孙男'],
		'm,xb,d,s,d':['舅表甥孙女','表甥孙女'],
		'm,xb,d,d':['舅表甥女','表外甥','表甥女'],
		'm,xb,d,d,h':['舅表甥婿'],
		'm,xb,d,d,s':['舅表甥外孙男','表甥外孙男'],
		'm,xb,d,d,d':['舅表甥外孙女','表甥外孙女'],
		'm,ob':['大舅'],
		'm,ob,w':['大舅妈'],
		'm,lb':['小舅','舅父仔'],
		'm,lb,w':['小舅妈'],
		// 从母
		'm,os':['大姨','大姨妈'],
		'm,os,h':['大姨父','大姨丈'],
		'm,ls':['小姨','小姨妈','姨仔'],
		'm,ls,h':['小姨父','小姨丈'],
		'm,xs':['姨妈','姨母','姨姨','姨娘','阿姨','姨','x姨','x姨妈'],
		'm,xs,h':['姨丈','姨父','姨爸','姨爹','姨婿','姨郎','x姨丈','x姨父'],
		'm,xs,h,f':['姨姻祖父','姻爷爷'],
		'm,xs,h,m':['姨姻祖母','姻奶奶'],
		'm,xs,h,ob':['姨姻伯父','姻伯父','姻世伯'],
		'm,xs,h,ob,w':['姨姻伯母','姻伯母'],
		'm,xs,h,lb':['姨姻叔父','姻叔父'],
		'm,xs,h,lb,w':['姨姻叔母','姻叔母'],
		'm,xs,h,xs':['姨姻姑母','姻姑母'],
		'm,xs,h,xs,h':['姨姻姑父','姻姑父'],
		'm,xs,s&o':['姨哥','姨兄','从母兄'],
		'm,xs,s&o,w':['姨嫂','姨兄妇','从母嫂','从母兄妇'],
		'm,xs,s&l':['姨弟','从母弟'],
		'm,xs,s&l,w':['姨弟妇','从母弟妇'],
		'm,xs,s,s':['姨侄男','从母侄男','姨侄'],
		'm,xs,s,s,w':['姨侄妇','从母侄妇'],
		'm,xs,s,s,s':['姨侄孙男','姨侄孙','从母侄孙'],
		'm,xs,s,s,s,w':['姨侄孙妇','从母侄孙妇'],
		'm,xs,s,s,d':['姨侄孙女','从母侄孙女'],
		'm,xs,s,s,d,h':['姨侄孙婿','从母侄孙婿'],
		'm,xs,s,d':['姨侄女','从母侄女','姨侄'],
		'm,xs,s,d,h':['姨侄婿','从母侄婿'],
		'm,xs,s,d,s':['姨侄外孙男','姨侄外孙','从母侄外孙'],
		'm,xs,s,d,s,w':['姨侄外孙妇','从母侄外孙妇'],
		'm,xs,s,d,d':['姨侄外孙女','从母侄外孙女'],
		'm,xs,s,d,d,h':['姨侄外孙婿','从母侄外孙婿'],
		'm,xs,d&o':['姨姐','姨姊','从母姐','从母姊'],
		'm,xs,d&o,h':['姨姐夫','姨姊夫','从母姐夫','从母姊夫','从母姊丈','从母姊婿','从母姊郎'],
		'm,xs,d&l':['姨妹','从母妹'],
		'm,xs,d&l,h':['姨妹夫','从母妹夫','从母妹丈','从母妹婿','从母妹郎'],
		'm,xs,d,s':['姨甥男','从母甥男','姨外甥','姨甥'],
		'm,xs,d,s,w':['姨甥妇','从母甥妇'],
		'm,xs,d,s,s':['姨甥孙男','姨甥孙','从母甥孙'],
		'm,xs,d,s,s,w':['姨甥孙妇','从母甥孙妇'],
		'm,xs,d,s,d':['姨甥孙女','从母甥孙女'],
		'm,xs,d,s,d,h':['姨甥孙婿','从母甥孙婿'],
		'm,xs,d,d':['姨甥女','从母甥女','姨外甥女','姨甥'],
		'm,xs,d,d,h':['姨甥婿','从母甥婿'],
		'm,xs,d,d,s':['姨甥外孙男','姨甥外孙','从母甥外孙'],
		'm,xs,d,d,s,w':['姨甥外孙妇','从母甥外孙妇'],
		'm,xs,d,d,d':['姨甥外孙女','从母甥外孙女'],
		'm,xs,d,d,d,h':['姨甥外孙婿','从母甥外孙婿'],
		// 婆家
		'h':['老公','丈夫','先生','官人','男人','汉子','夫','夫君','相公','夫婿','良人','爱人','老伴','老头子'],
		'h,f':['公公','翁亲','老公公'],
		'h,f,f':['祖公','祖翁','奶公父'],
		'h,f,f,f':['曾祖公','太公翁'],
		'h,f,f,f,ob':['伯曾祖公','太伯翁'],
		'h,f,f,f,ob,w':['伯曾祖婆','太姆婆'],
		'h,f,f,f,lb':['叔曾祖公','太叔翁'],
		'h,f,f,f,lb,w':['叔曾祖婆','太婶婆'],
		'h,f,f,m':['曾祖婆','太奶亲'],
		'h,f,f,ob':['伯祖公','伯祖翁'],
		'h,f,f,ob,w':['伯祖婆'],
		'h,f,f,lb':['叔祖公','叔祖翁'],
		'h,f,f,lb,w':['叔祖婆'],
		'h,f,f,xb,s&o':['堂伯老爷'],
		'h,f,f,xb,s&o,w':['堂伯奶奶'],
		'h,f,f,xb,s&l':['堂叔老爷'],
		'h,f,f,xb,s&l,w':['堂叔奶奶'],
		'h,f,f,xb,s,s&o':['从堂大伯'],
		'h,f,f,xb,s,s&o,w':['从堂嫂'],
		'h,f,f,xb,s,s&l':['从堂叔仔'],
		'h,f,f,xb,s,s&l,w':['从堂弟媳'],
		'h,f,f,xb,s,d&o':['从堂大姑'],
		'h,f,f,xb,s,d&o,h':['从堂大姑夫'],
		'h,f,f,xb,s,d&l':['从堂小姑'],
		'h,f,f,xb,s,d&l,h':['从堂小姑夫'],
		'h,f,f,xb,d':['堂姑奶奶'],
		'h,f,f,xb,d,h':['堂姑老爷'],
		'h,f,f,xb,d,d&o':['堂姑表大姑'],
		'h,f,f,xb,d,d&o,h':['堂姑表大姑夫'],
		'h,f,f,xb,d,d&l':['堂姑表小姑'],
		'h,f,f,xb,d,d&l,h':['堂姑表小姑夫'],
		'h,f,f,xs':['姑祖婆'],
		'h,f,f,xs,h':['姑祖公'],
		'h,f,m':['祖婆','奶婆母'],
		'h,f,m,f':['曾外祖公'],
		'h,f,m,m':['曾外祖婆'],
		'h,f,m,xb':['舅祖公'],
		'h,f,m,xb,w':['舅祖婆'],
		'h,f,m,xs':['姨祖婆'],
		'h,f,m,xs,h':['姨祖公'],
		'h,f,ob':['伯公父','伯翁'],
		'h,f,ob,w':['伯婆母','伯婆'],
		'h,f,lb':['叔公父','叔公','叔翁','叔祖'],
		'h,f,lb,w':['叔婆母','叔婆','婶婆','婶亲'],
		'h,f,xb,s&o':['堂大伯子','从父大伯子','从父大伯兄','堂大伯','从父大伯','夫从兄'],
		'h,f,xb,s&o,w':['堂大伯嫂','从父大伯嫂','堂大姆','从父大姆','从兄嫂'],
		'h,f,xb,s&l':['堂小叔弟','从父小叔弟','堂叔仔','从父叔仔','夫从弟'],
		'h,f,xb,s&l,w':['堂小叔弟妇','从父小叔弟妇','堂小弟','从父小弟','从弟妇'],
		'h,f,xb,s,s':['堂夫侄男','从父夫侄男'],
		'h,f,xb,s,d':['堂夫侄女','从父夫侄女'],
		'h,f,xb,d&o':['堂大姑姐','从父大姑姐','从父大姑姊'],
		'h,f,xb,d&o,h':['堂大姑姐夫','从父大姑姐夫','从父大姑姊夫'],
		'h,f,xb,d&l':['堂小姑妹','从父小姑妹'],
		'h,f,xb,d&l,h':['堂小姑妹夫','从父小姑妹夫'],
		'h,f,xb,d,s':['堂夫甥男','从父夫甥男'],
		'h,f,xb,d,d':['堂夫甥女','从父夫甥女'],
		'h,f,xs':['姑婆母','姑婆'],
		'h,f,xs,h':['姑公父','姑公'],
		'h,f,xs,s&o':['姑表大伯子','姑表大伯兄','表大伯'],
		'h,f,xs,s&o,w':['姑表大伯嫂','表大姆'],
		'h,f,xs,s&l':['姑表小叔弟','表叔仔'],
		'h,f,xs,s&l,w':['姑表小叔弟妇','表小弟'],
		'h,f,xs,s,s':['姑表夫侄男'],
		'h,f,xs,s,d':['姑表夫侄女'],
		'h,f,xs,d&o':['姑表大姑姐','姑表大姑姊','表大姑'],
		'h,f,xs,d&o,h':['姑表大姑姐夫','姑表大姑姊夫'],
		'h,f,xs,d&l':['姑表小姑妹','表姑仔'],
		'h,f,xs,d&l,h':['姑表小姑妹夫'],
		'h,f,xs,d,s':['姑表夫甥男'],
		'h,f,xs,d,d':['姑表夫甥女'],
		'h,m':['婆婆','婆母','姑亲','老婆婆'],
		'h,m,f':['外祖公','姥公父','姥公'],
		'h,m,f,f':['外曾祖公'],
		'h,m,f,m':['外曾祖婆'],
		'h,m,f,ob':['伯外祖公'],
		'h,m,f,ob,w':['伯外祖婆'],
		'h,m,f,lb':['叔外祖公'],
		'h,m,f,lb,w':['叔外祖婆'],
		'h,m,f,xs':['姑外祖婆'],
		'h,m,f,xs,h':['姑外祖公'],
		'h,m,m':['外祖婆','姥婆母','姥婆'],
		'h,m,m,f':['外曾外祖公'],
		'h,m,m,m':['外曾外祖婆'],
		'h,m,m,xb':['舅外祖公'],
		'h,m,m,xb,w':['舅外祖婆'],
		'h,m,m,xs':['姨外祖婆'],
		'h,m,m,xs,h':['姨外祖公'],
		'h,m,xb':['舅公父','舅公'],
		'h,m,xb,w':['舅婆母','舅婆'],
		'h,m,xb,s&o':['舅表大伯子','舅表大伯兄','表大伯'],
		'h,m,xb,s&o,w':['舅表大伯嫂','表大姆'],
		'h,m,xb,s&l':['舅表小叔弟','表叔仔'],
		'h,m,xb,s&l,w':['舅表小叔弟妇','表小弟'],
		'h,m,xb,s,s':['舅表夫侄男'],
		'h,m,xb,s,d':['舅表夫侄女'],
		'h,m,xb,d&o':['舅表大姑姐','舅表大姑姊','表大姑'],
		'h,m,xb,d&o,h':['舅表大姑姐夫','舅表大姑姊夫'],
		'h,m,xb,d&l':['舅表小姑妹','表姑仔'],
		'h,m,xb,d&l,h':['舅表小姑妹夫'],
		'h,m,xb,d,s':['舅表夫甥男'],
		'h,m,xb,d,d':['舅表夫甥女'],
		'h,m,xs':['姨婆母','姨婆'],
		'h,m,xs,h':['姨公父','姨公'],
		'h,m,xs,s&o':['姨大伯子','从母大伯子','从母大伯兄','姨大伯','从母大伯'],
		'h,m,xs,s&o,w':['姨大伯嫂','从母大伯嫂','姨大姆','从母大姆'],
		'h,m,xs,s&l':['姨小叔弟','从母小叔弟','姨叔仔','从母叔仔'],
		'h,m,xs,s&l,w':['姨小叔弟妇','从母小叔弟妇','姨小弟','从母小弟'],
		'h,m,xs,s,s':['姨夫侄男','从母夫侄男'],
		'h,m,xs,s,d':['姨夫侄女','从母夫侄女'],
		'h,m,xs,d&o':['姨大姑姐','从母大姑姊','从母大姑姐'],
		'h,m,xs,d&o,h':['姨大姑姐夫','从母大姑姊夫','从母大姑姐夫'],
		'h,m,xs,d&l':['姨小姑妹','从母小姑妹'],
		'h,m,xs,d&l,h':['姨小姑妹夫','从母小姑妹夫'],
		'h,m,xs,d,s':['姨夫甥男','从母夫甥男'],
		'h,m,xs,d,d':['姨夫甥女','从母夫甥女'],
		'h,ob':['大伯子','大伯哥','大伯兄','夫兄'],
		'h,ob,w':['大婶子','伯嫂','大伯嫂','大伯妇','伯娘','大伯娘','大嫂','夫兄嫂','妯娌'],
		'h,lb':['小叔子','小叔弟'],
		'h,lb,w':['小婶子','叔嫂','小叔妇','小叔媳妇','小叔弟妇','妯娌'],
		'h,xb':['伯叔'],
		'h,xb,s':['婆家侄','叔侄男','叔伯男','从男','婆家侄男'],
		'h,xb,s,w':['叔侄媳妇','叔伯侄妇','叔伯妇','叔侄妇'],
		'h,xb,s,s':['叔侄孙男'],
		'h,xb,s,s,w':['叔侄孙妇'],
		'h,xb,s,d':['叔侄孙女'],
		'h,xb,s,d,h':['叔侄孙婿'],
		'h,xb,d':['叔侄女','叔伯女','从女','婆家侄女'],
		'h,xb,d,h':['叔侄婿'],
		'h,xb,d,s':['叔侄外孙男'],
		'h,xb,d,s,w':['叔侄外孙妇'],
		'h,xb,d,d':['叔侄外孙女'],
		'h,xb,d,d,h':['叔侄外孙婿'],
		'h,os':['大姑子','大姑','大娘姑','大姑姊','夫姐'],
		'h,os,h':['大姑夫','姊丈','大姑姐夫','大姑姊夫'],
		'h,ls':['小姑子','小姑','小姑妹','姑仔','夫妹'],
		'h,ls,h':['小姑夫','小亘子','小姑妹夫'],
		'h,xs,s':['姑甥男','姑男','婆家甥男'],
		'h,xs,s,w':['姑甥妇','姑妇'],
		'h,xs,s,s':['姑甥孙男'],
		'h,xs,s,s,w':['姑甥孙妇'],
		'h,xs,s,d':['姑甥孙女'],
		'h,xs,s,d,h':['姑甥孙婿'],
		'h,xs,d':['姑甥女','姑女','婆家甥女'],
		'h,xs,d,h':['姑甥婿'],
		'h,xs,d,s':['姑甥外孙男'],
		'h,xs,d,s,w':['姑甥外孙妇'],
		'h,xs,d,d':['姑甥外孙女'],
		'h,xs,d,d,h':['姑甥外孙婿'],
		// 岳家
		'w':['老婆','妻子','太太','媳妇儿','媳妇','夫人','女人','婆娘','妻','内人','娘子','爱人','爱妻','老伴','老太婆'],
		'w,f':['岳父','岳丈','老丈人','丈人','泰山','妻父'],
		'w,f,f':['祖岳父','岳祖父','太岳父','奶岳父'],
		'w,f,f,f':['曾祖岳父','岳曾祖父','曾祖丈人'],
		'w,f,f,f,xb,s,s&o':['姻伯丈'],
		'w,f,f,f,xb,s,s&o,w':['姻姆'],
		'w,f,f,f,xb,s,s&l':['姻叔丈'],
		'w,f,f,f,xb,s,s&l,w':['姻婶'],
		'w,f,f,m':['曾祖岳母','岳曾祖母','曾祖丈母'],
		'w,f,f,ob':['伯祖岳父','岳伯祖父','太伯岳'],
		'w,f,f,ob,w':['伯祖岳母','岳伯祖母','太伯岳母'],
		'w,f,f,lb,':['叔祖岳父','岳叔祖父','太叔岳'],
		'w,f,f,lb,w':['叔祖岳母','岳叔祖母','太叔岳母'],
		'w,f,f,xb,s&o':['姻伯'],
		'w,f,f,xb,s&o,w':['姻姆'],
		'w,f,f,xb,s&l':['姻叔'],
		'w,f,f,xb,s&l,w':['姻婶'],
		'w,f,f,xs':['姑祖岳母','岳姑祖母','太姑岳母'],
		'w,f,f,xs,h':['姑祖岳父','岳姑祖父','太姑岳父'],
		'w,f,m':['祖岳母','岳祖母','太岳母','奶岳母'],
		'w,f,m,f':['曾外祖岳父','岳曾外祖父','曾外祖丈人'],
		'w,f,m,m':['曾外祖岳母','岳曾外祖母','曾外祖丈母'],
		'w,f,m,xb':['舅祖岳父','岳舅祖父','太舅岳父'],
		'w,f,m,xb,w':['舅祖岳母','岳舅祖母','太舅岳母'],
		'w,f,m,xs':['姨祖岳母','岳姨祖母','太姨岳母'],
		'w,f,m,xs,h':['姨祖岳父','岳姨祖父','太姨岳父'],
		'w,f,ob':['伯岳','伯岳父'],
		'w,f,ob,w':['伯岳母'],
		'w,f,lb':['叔岳','叔岳父'],
		'w,f,lb,w':['叔岳母'],
		'w,f,xb,s&o':['内堂舅兄','内堂大舅','内堂大舅兄','堂大舅兄','从父大舅兄','堂大舅','内堂兄','堂内兄'],
		'w,f,xb,s&o,w':['内堂舅嫂','内堂嫂','堂内嫂','从父内嫂'],
		'w,f,xb,s&l':['内堂舅弟','内堂舅仔','内堂小舅弟','堂小舅弟','从父小舅弟','堂舅仔','内堂弟','堂内弟'],
		'w,f,xb,s&l,w':['内堂舅弟媳','内堂弟妇','堂内弟妇','从父内弟妇'],
		'w,f,xb,d&o':['内堂姨姐','内堂大姨姊','堂大姨姊','从父大姨姊','堂大姨','内堂姐','堂内姐'],
		'w,f,xb,d&o,h':['内堂姨姐夫','内堂襟兄','堂襟兄','从父襟兄'],
		'w,f,xb,d&l':['内堂姨妹','内堂小姨妹','堂小姨妹','从父小姨妹','堂姨仔','内堂妹','堂内妹'],
		'w,f,xb,d&l,h':['内堂姨妹夫','内堂襟弟','堂襟弟','从父襟弟'],
		'w,f,xs':['姑岳母'],
		'w,f,xs,h':['姑岳父'],
		'w,f,xs,s&o':['内姑表舅兄','内姑表大舅','内姑表大舅兄','表大舅兄','表大舅','内表兄','表内兄'],
		'w,f,xs,s&o,w':['内姑表舅嫂','内表嫂','表内嫂'],
		'w,f,xs,s&l':['内姑表舅弟','内姑表舅仔','内姑表小舅弟','表小舅弟','表舅仔','内表弟','表内弟'],
		'w,f,xs,s&l,w':['内姑表舅弟媳','内表弟妇','表内弟妇'],
		'w,f,xs,d&o':['内姑表姨姐','内姑表大姨姊','表大姨姊','表大姨','内表姐','表内姐'],
		'w,f,xs,d&o,h':['内姑表姨姐夫','内姑表襟兄','姑表襟兄','表襟兄'],
		'w,f,xs,d&l':['内姑表姨妹','内姑表小姨妹','表小姨妹','表姨仔','内表妹','表内妹'],
		'w,f,xs,d&l,h':['内姑表姨妹夫','内姑表襟弟','姑表襟弟','表襟弟'],
		'w,m':['岳母','丈母娘','老丈母','丈母','泰水'],
		'w,m,f':['外祖岳父','岳外祖父','外祖丈人','丈人外祖父','外太岳父','姥岳父','姥丈人','丈人姥爷'],
		'w,m,f,f':['外曾祖岳父','岳外曾祖父','外曾祖丈人'],
		'w,m,f,m':['外曾祖岳母','岳外曾祖母','外曾祖丈母'],
		'w,m,f,ob':['伯外祖岳父','岳伯外祖父'],
		'w,m,f,ob,w':['伯外祖岳母','岳伯外祖母'],
		'w,m,f,lb':['叔外祖岳父','岳叔外祖父'],
		'w,m,f,lb,w':['叔外祖岳母','岳叔外祖母'],
		'w,m,f,xs':['姑外祖岳母','岳姑外祖母'],
		'w,m,f,xs,h':['姑外祖岳父','岳姑外祖父'],
		'w,m,m':['外祖岳母','岳外祖母','外祖丈母娘','外祖丈母','丈人外祖母','外太岳母','姥岳母','姥丈母','丈人姥姥'],
		'w,m,m,f':['外曾外祖岳父','岳外曾外祖父','外曾外祖丈人'],
		'w,m,m,m':['外曾外祖岳母','岳外曾外祖母','外曾外祖丈母'],
		'w,m,m,xb':['舅外祖岳父','岳舅外祖父'],
		'w,m,m,xb,w':['舅外祖岳母','岳舅外祖母'],
		'w,m,m,xs':['姨外祖岳母','岳姨外祖母'],
		'w,m,m,xs,h':['姨外祖岳父','岳姨外祖父'],
		'w,m,xb':['舅岳父'],
		'w,m,xb,w':['舅岳母'],
		'w,m,xb,s&o':['内舅表舅兄','内舅表大舅','内舅表大舅兄','表大舅兄','表大舅','内表兄','表内兄'],
		'w,m,xb,s&o,w':['内舅表舅嫂','内表嫂','表内嫂'],
		'w,m,xb,s&l':['内舅表舅弟','内舅表舅仔','内舅表小舅弟','表小舅弟','表舅仔','内表弟','表内弟'],
		'w,m,xb,s&l,w':['内舅表舅弟媳','舅表弟妇','表内弟妇'],
		'w,m,xb,d&o':['内舅表姨姐','内舅表大姨姊','表大姨姊','表大姨','内表姐','表内姐'],
		'w,m,xb,d&o,h':['内舅表姨姐夫','内舅表襟兄','舅表襟兄','表襟兄'],
		'w,m,xb,d&l':['内舅表姨妹','内舅表小姨妹','表小姨妹','表姨仔','内表妹','表内妹'],
		'w,m,xb,d&l,h':['内舅表姨妹夫','内舅表襟弟','舅表襟弟','表襟弟'],
		'w,m,xs':['姨岳母'],
		'w,m,xs,h':['姨岳父'],
		'w,m,xs,s&o':['内姨舅兄','内姨大舅','内姨大舅兄','姨大舅兄','从母大舅兄','姨大舅','内姨兄','姨内兄'],
		'w,m,xs,s&o,w':['内姨舅嫂','内姨嫂','姨内嫂','从母内嫂'],
		'w,m,xs,s&l':['内姨舅弟','内姨舅仔','内姨小舅弟','姨小舅弟','从母小舅弟','姨舅仔','内姨弟','姨内弟'],
		'w,m,xs,s&l,w':['内姨舅弟媳','内姨弟妇','姨内弟妇','从母内弟妇'],
		'w,m,xs,d&o':['内姨姨姐','内姨大姨姊','姨大姨姊','从母大姨姊','姨大姨','内姨姐','姨内姐'],
		'w,m,xs,d&o,h':['内姨姨姐夫','内姨襟兄','姨襟兄','从母襟兄'],
		'w,m,xs,d&l':['内姨姨妹','内姨小姨妹','姨小姨妹','从母小姨妹','姨姨仔','内姨妹','姨内妹'],
		'w,m,xs,d&l,h':['内姨姨妹夫','内姨襟弟','姨襟弟','从母襟弟'],
		'w,ob':['大舅子','大舅哥','大舅兄','内兄','妻兄','妻舅','舅兄'],
		'w,ob,w':['舅嫂','大舅妇','大舅嫂','大舅媳妇','大妗子','内嫂','妻兄嫂'],
		'w,lb':['小舅子','小舅弟','内弟','妻弟','妻舅','舅弟'],
		'w,lb,w':['舅弟媳','小舅妇','小舅弟妇','小舅媳妇','小妗子','妻妹夫'],
		'w,xb,s':['内侄','内侄男','妻侄男','舅侄男','岳侄男','丈人侄男','舅男'],
		'w,xb,s,w':['内侄妇','内侄媳妇','妻侄妇','舅侄妇','岳侄妇','丈人侄妇','舅妇'],
		'w,xb,s,s':['内侄孙','内侄孙男','妻侄孙男'],
		'w,xb,s,s,w':['内侄孙妇','妻侄孙妇'],
		'w,xb,s,s,s':['内曾侄孙','内曾侄孙男'],
		'w,xb,s,s,s,w':['内曾侄孙妇'],
		'w,xb,s,s,d':['内曾侄孙女'],
		'w,xb,s,s,d,h':['内曾侄孙婿'],
		'w,xb,s,d':['内侄孙女','妻侄孙女'],
		'w,xb,s,d,h':['内侄孙婿','妻侄孙婿'],
		'w,xb,d':['内侄女','内侄','妻侄女','舅侄女','岳侄女','丈人侄女','舅女'],
		'w,xb,d,h':['内侄婿','妻侄婿','舅侄婿','岳侄婿','丈人侄婿'],
		'w,xb,d,s':['内侄外孙','内侄外孙男','姨侄外孙男'],
		'w,xb,d,s,w':['内侄外孙妇','姨侄外孙妇'],
		'w,xb,d,d':['内侄外孙女','姨侄外孙女'],
		'w,xb,d,d,h':['内侄外孙婿','姨侄外孙婿'],
		'w,os':['大姨子','大姨姐','大姨姊','妻姐'],
		'w,os,h':['大姨夫','大姨姐夫','大姨姊夫','襟兄','连襟','连桥','姨夫'],
		'w,ls':['小姨子','小姨妹','妻妹','小妹儿'],
		'w,ls,h':['小姨夫','小姨妹夫','襟弟','连襟','连桥','姨夫'],
		'w,xs,s':['内甥男','内甥','妻甥男','姨甥男','岳甥男','丈人甥男','姨男','从男'],
		'w,xs,s,w':['内甥妇','姨甥妇','岳甥妇','丈人甥妇','姨妇'],
		'w,xs,s,s':['内甥孙男','姨甥孙男'],
		'w,xs,s,s,w':['内甥孙妇','姨甥孙妇'],
		'w,xs,s,d':['内甥孙女','姨甥孙女'],
		'w,xs,s,d,h':['内甥孙婿','姨甥孙婿'],
		'w,xs,d':['内甥女','内甥','姨甥女','妻外甥女','丈人甥女','姨女','从女'],
		'w,xs,d,h':['内甥婿','姨甥婿','妻甥婿','岳甥婿','丈人甥婿'],
		'w,xs,d,s':['内甥外孙男','姨甥外孙男'],
		'w,xs,d,s,w':['内甥外孙妇','姨甥外孙妇'],
		'w,xs,d,d':['内甥外孙女','姨甥外孙女'],
		'w,xs,d,d,h':['内甥外孙婿','姨甥外孙婿'],
		// 兄弟
		'ob':['哥哥','哥','兄','阿哥','大佬','老哥','兄长','胞哥','大哥','x哥'],
		'ob,w':['嫂子','嫂','嫂嫂','阿嫂','兄嫂','大嫂','x嫂'],
		'ob,w,f':['兄姻父','兄眷父','姻父'],
		'ob,w,f,f':['兄姻公'],
		'ob,w,f,m':['兄姻婆'],
		'ob,w,m':['兄姻母','兄眷母','姻母'],
		'ob,w,ob':['兄姻兄','兄眷兄','姻兄'],
		'ob,w,ob,w':['兄姻兄妇','兄眷兄妇'],
		'ob,w,lb':['兄姻弟','兄眷弟','姻弟'],
		'ob,w,lb,w':['兄姻弟妇','兄眷弟妇'],
		'ob,w,xb,s':['兄姻侄男','兄眷侄男'],
		'ob,w,xb,d':['兄姻侄女','兄眷侄女'],
		'ob,w,os':['兄姻姊','兄眷姊','姻姊'],
		'ob,w,os,h':['兄姻姊婿','兄眷姊婿'],
		'ob,w,ls':['兄姻妹','兄眷妹','姻妹'],
		'ob,w,ls,h':['兄姻妹婿'],
		'ob,w,xs,s':['兄姻甥男','兄眷甥男'],
		'ob,w,xs,d':['兄姻甥女','兄眷甥女'],
		'lb':['弟弟','弟','细佬','胞弟','老弟','x弟'],
		'lb,w':['弟妹','弟媳','弟媳妇','弟妇','x弟妹'],
		'lb,w,f':['弟姻父','弟眷母','姻父'],
		'lb,w,f,f':['弟姻公'],
		'lb,w,f,m':['弟姻婆'],
		'lb,w,m':['弟姻母','弟眷母','姻母'],
		'lb,w,ob':['弟姻兄','弟眷兄','姻兄'],
		'lb,w,ob,w':['弟姻兄妇','弟眷兄妇'],
		'lb,w,lb':['弟姻弟','弟眷弟','姻弟'],
		'lb,w,lb,w':['弟姻弟妇','弟眷弟妇'],
		'lb,w,xb,s':['弟姻侄男','弟眷侄男'],
		'lb,w,xb,d':['弟姻侄女','弟眷侄女'],
		'lb,w,os':['弟姻姊','弟眷姊','姻姊'],
		'lb,w,os,h':['弟姻姊婿','弟眷姊婿'],
		'lb,w,ls':['弟姻妹','弟眷妹','姻妹'],
		'lb,w,ls,h':['弟姻妹婿','弟眷妹婿'],
		'lb,w,xs,s':['弟姻甥男','弟眷甥男'],
		'lb,w,xs,d':['弟姻甥女','弟眷甥女'],
		'xb':['兄弟'],
		'xb,w,f,ob':['姻伯父'],
		'xb,w,f,ob,w':['姻伯母'],
		'xb,w,f,lb':['姻叔父'],
		'xb,w,f,lb,w':['姻叔母'],
		'0,xb,w,xb,s':['舅眷舅男'],
		'1,xb,w,xb,s':['叔眷舅男'],
		'0,xb,w,xb,d':['舅眷舅女'],
		'1,xb,w,xb,d':['叔眷舅女'],
		'0,xb,w,xs,s':['舅眷姨男'],
		'1,xb,w,xs,s':['叔眷姨男'],
		'0,xb,w,xs,d':['舅眷姨女'],
		'1,xb,w,xs,d':['叔眷姨女'],
		'xb,s':['侄子','侄男','侄男儿','侄儿','阿侄'],
		'xb,s,w':['侄媳妇','侄妇'],
		'xb,s,s':['侄孙男','侄孙子'],
		'xb,s,s,w':['侄孙妇'],
		'xb,s,s,s':['侄曾孙'],
		'xb,s,s,s,w':['侄曾孙妇'],
		'xb,s,s,s,s':['侄玄孙'],
		'xb,s,s,s,d':['侄玄孙女'],
		'xb,s,s,d':['侄曾孙女'],
		'xb,s,s,d,h':['侄曾孙婿'],
		'xb,s,s,d,s':['侄玄外孙'],
		'xb,s,s,d,d':['侄玄外孙女'],
		'xb,s,d':['侄孙女'],
		'xb,s,d,h':['侄孙婿'],
		'xb,s,d,s':['侄曾外孙'],
		'xb,s,d,s,w':['侄曾外孙妇'],
		'xb,s,d,s,s':['侄曾外曾孙'],
		'xb,s,d,s,d':['侄曾外曾孙女'],
		'xb,s,d,d':['侄曾外孙女'],
		'xb,s,d,d,h':['侄曾外孙婿'],
		'xb,s,d,d,s':['侄曾外曾外孙'],
		'xb,s,d,d,d':['侄曾外曾外孙女'],
		'xb,d':['侄女','侄女儿','侄囡'],
		'xb,d,h':['侄女婿','侄婿'],
		'xb,d,s':['侄外孙','外侄孙'],
		'xb,d,s,w':['侄外孙妇','外侄孙妇'],
		'xb,d,s,s':['侄外曾孙'],
		'xb,d,s,s,w':['侄外曾孙妇'],
		'xb,d,s,s,s':['侄外玄孙'],
		'xb,d,s,s,d':['侄外玄孙女'],
		'xb,d,s,d':['侄外曾孙女'],
		'xb,d,s,d,h':['侄外曾孙婿'],
		'xb,d,s,d,s':['侄外玄外孙'],
		'xb,d,s,d,d':['侄外玄外孙女'],
		'xb,d,d':['侄外孙女','外侄孙女'],
		'xb,d,d,h':['侄外孙婿','外侄孙婿'],
		'xb,d,d,s':['侄外曾外孙'],
		'xb,d,d,s,w':['侄外曾外孙妇'],
		'xb,d,d,s,s':['侄外曾外曾孙'],
		'xb,d,d,s,d':['侄外曾外曾孙女'],
		'xb,d,d,d':['侄外曾外孙女'],
		'xb,d,d,d,h':['侄外曾外孙婿'],
		'xb,d,d,d,s':['侄外曾外曾外孙'],
		'xb,d,d,d,d':['侄外曾外曾外孙女'],
		// 姐妹
		'os':['姐姐','姐','家姐','阿姐','阿姊','胞姐','大姐','x姐'],
		'os,h':['姐夫','姊夫','姊丈','姊婿','大姐夫','x姐夫'],
		'os,h,f':['姊姻父','姻父'],
		'os,h,m':['姊姻母','姻母'],
		'os,h,ob':['姊姻兄','姻兄'],
		'os,h,ob,w':['姊姻兄妇'],
		'os,h,lb':['姊姻弟','姻弟'],
		'os,h,lb,w':['姊姻弟妇'],
		'os,h,xb,s':['姊姻甥男'],
		'os,h,xb,d':['姊姻甥女'],
		'os,h,os':['姊姻姊','姻姊'],
		'os,h,os,h':['姊姻姊婿'],
		'os,h,ls':['姊姻妹','姻妹'],
		'os,h,ls,h':['姊姻妹婿'],
		'os,h,xs,s':['姊姻侄男'],
		'os,h,xs,d':['姊姻侄女'],
		'ls':['妹妹','妹','胞妹','老妹','x妹'],
		'ls,h':['妹夫','妹丈','妹婿','x妹夫'],
		'ls,h,f':['妹姻父','姻父'],
		'ls,h,m':['妹姻母','姻母'],
		'ls,h,ob':['妹姻兄','姻兄'],
		'ls,h,ob,w':['妹姻兄妇'],
		'ls,h,lb':['妹姻弟','姻弟'],
		'ls,h,lb,w':['妹姻弟妇'],
		'ls,h,xb,s':['妹姻甥男'],
		'ls,h,xb,d':['妹姻甥女'],
		'ls,h,os':['妹姻姊','姻姊'],
		'ls,h,os,h':['妹姻姊婿'],
		'ls,h,ls':['妹姻妹','姻妹'],
		'ls,h,ls,h':['妹姻妹婿'],
		'ls,h,xs,s':['妹姻侄男'],
		'ls,h,xs,d':['妹姻侄女'],
		'xs':['姐妹','姊妹'],
		'xs,h,f,ob':['姻伯父'],
		'xs,h,f,ob,w':['姻伯母'],
		'xs,h,f,lb':['姻叔父'],
		'xs,h,f,lb,w':['姻叔母'],
		'0,xs,h,xb,s':['姨姻叔男'],
		'1,xs,h,xb,s':['姑姻叔男'],
		'0,xs,h,xb,d':['姨姻叔女'],
		'1,xs,h,xb,d':['姑姻叔女'],
		'0,xs,h,xs,s':['姨姻姑男'],
		'1,xs,h,xs,s':['姑姻姑男'],
		'0,xs,h,xs,d':['姨姻姑女'],
		'1,xs,h,xs,d':['姑姻姑女'],
		'xs,s':['外甥','外甥男','甥男','甥儿','甥子','外甥儿','外甥子','外甥儿子'],
		'xs,s,w':['外甥媳妇','甥媳妇','甥妇'],
		'xs,s,s':['甥孙'],
		'xs,s,s,w':['甥孙妇'],
		'xs,s,s,s':['甥曾孙'],
		'xs,s,s,s,w':['甥曾孙妇'],
		'xs,s,s,s,s':['甥玄孙'],
		'xs,s,s,s,s':['甥玄孙女'],
		'xs,s,s,d':['甥曾孙女'],
		'xs,s,s,d,h':['甥曾孙婿'],
		'xs,s,s,d,s':['甥玄外孙'],
		'xs,s,s,d,d':['甥玄外孙女'],
		'xs,s,d':['甥孙女'],
		'xs,s,d,h':['甥孙婿'],
		'xs,s,d,s':['甥曾外孙'],
		'xs,s,d,s,w':['甥曾外孙妇'],
		'xs,s,d,s,s':['甥曾外曾孙'],
		'xs,s,d,s,d':['甥曾外曾孙女'],
		'xs,s,d,d':['甥曾外孙女'],
		'xs,s,d,d,h':['甥曾外孙女'],
		'xs,s,d,d,s':['甥曾外曾外孙'],
		'xs,s,d,d,d':['甥曾外曾外孙女'],
		'xs,d':['外甥女','甥女','外甥囡'],
		'xs,d,h':['外甥女婿','甥女婿','甥婿'],
		'xs,d,s':['甥外孙'],
		'xs,d,s,w':['甥外孙妇'],
		'xs,d,s,s':['甥外曾孙'],
		'xs,d,s,s,w':['甥外曾孙妇'],
		'xs,d,s,s,s':['甥外玄孙'],
		'xs,d,s,s,d':['甥外玄孙女'],
		'xs,d,s,d':['甥外曾孙女'],
		'xs,d,s,d,h':['甥外曾孙婿'],
		'xs,d,s,d,s':['甥外玄外孙'],
		'xs,d,s,d,d':['甥外玄外孙女'],
		'xs,d,d':['甥外孙女'],
		'xs,d,d,h':['甥外孙婿'],
		'xs,d,d,s':['甥外曾外孙'],
		'xs,d,d,s,w':['甥外曾外孙妇'],
		'xs,d,d,s,s':['甥外曾外曾孙'],
		'xs,d,d,s,d':['甥外曾外曾孙女'],
		'xs,d,d,d':['甥外曾外孙女'],
		'xs,d,d,d,h':['甥外曾外孙婿'],
		'xs,d,d,d,s':['甥外曾外曾外孙'],
		'xs,d,d,d,d':['甥外曾外曾外孙女'],
		//自家
		's':['儿子','男儿','儿','仔','阿仔','仔仔','x儿子'],
		's,w':['儿媳','儿媳妇','新妇'],
		's,s':['孙子','孙男','孙儿','x孙子','孙'],
		's,s,w':['孙媳妇','孙媳','孙妇'],
		's,s,w,xb':['姻家再侄'],
		's,s,w,xs':['姻家再侄'],
		's,s,s':['曾孙','曾孙男','重孙'],
		's,s,s,w':['曾孙妇'],
		's,s,s,s':['玄孙','元孙','膀孙'],
		's,s,s,s,w':['玄孙媳妇'],
		's,s,s,s,s':['来孙'],
		's,s,s,s,s,w':['来孙媳妇'],
		's,s,s,s,s,s':['晜孙'],
		's,s,s,s,s,s,w':['晜孙媳妇'],
		's,s,s,s,s,s,s':['仍孙'],
		's,s,s,s,s,s,s,w':['仍孙媳妇'],
		's,s,s,s,s,s,s,s':['云孙'],
		's,s,s,s,s,s,s,s,s':['耳孙'],
		's,s,s,s,s,s,s,s,s,w':['耳孙媳妇'],
		's,s,s,s,s,s,s,s,d':['耳孙女'],
		's,s,s,s,s,s,s,s,d,h':['耳孙女婿'],
		's,s,s,s,s,s,s,d':['云孙女'],
		's,s,s,s,s,s,s,d,h':['云孙女婿'],
		's,s,s,s,s,s,s,d,s':['耳外孙'],
		's,s,s,s,s,s,s,d,s,w':['耳外孙媳妇'],
		's,s,s,s,s,s,s,d,d':['耳外孙女'],
		's,s,s,s,s,s,s,d,d,h':['耳外孙女婿'],
		's,s,s,s,s,s,d':['仍孙女'],
		's,s,s,s,s,s,d,h':['仍孙女婿'],
		's,s,s,s,s,s,d,s':['云外孙'],
		's,s,s,s,s,s,d,s,w':['云外孙媳妇'],
		's,s,s,s,s,s,d,d':['云外孙女'],
		's,s,s,s,s,s,d,d,h':['云外孙女婿'],
		's,s,s,s,s,d':['晜孙女'],
		's,s,s,s,s,d,h':['晜孙女婿'],
		's,s,s,s,s,d,s':['仍外孙'],
		's,s,s,s,s,d,s,w':['仍外孙媳妇'],
		's,s,s,s,s,d,d':['仍外孙女'],
		's,s,s,s,s,d,d,h':['仍外孙女婿'],
		's,s,s,s,d':['来孙女'],
		's,s,s,s,d,h':['来孙女婿'],
		's,s,s,s,d,s':['晜外孙'],
		's,s,s,s,d,s,w':['晜外孙媳妇'],
		's,s,s,s,d,d':['晜外孙女'],
		's,s,s,s,d,d,h':['晜外孙女婿'],
		's,s,s,d':['玄孙女'],
		's,s,s,d,h':['玄孙女婿'],
		's,s,s,d,s':['来外孙'],
		's,s,s,d,s,w':['来外孙媳妇'],
		's,s,s,d,d':['来外孙女'],
		's,s,s,d,d,h':['来外孙女婿'],
		's,s,d':['曾孙女'],
		's,s,d,h':['曾孙婿'],
		's,s,d,s':['玄外孙'],
		's,s,d,s,w':['玄外孙媳妇'],
		's,s,d,d':['玄外孙女'],
		's,s,d,d,h':['玄外孙女婿'],
		's,d':['孙女','孙囡'],
		's,d,h':['孙女婿','孙婿'],
		's,d,h,xb':['姻家再侄男','姻家再侄'],
		's,d,h,xs':['姻家再侄女','姻家再侄'],
		's,d,s':['曾外孙'],
		's,d,s,w':['曾外孙媳妇','曾外孙妇'],
		's,d,s,s':['曾外曾孙'],
		's,d,s,d':['曾外曾孙女'],
		's,d,d':['曾外孙女'],
		's,d,d,h':['曾外孙女婿','曾外孙婿'],
		's,d,d,s':['曾外曾外孙'],
		's,d,d,d':['曾外曾外孙女'],
		'd':['女儿','千金','闺女','女','阿女','女女','掌上明珠','乖囡','囡囡','姑娘','x女儿'],
		'd,h':['女婿','姑爷','女婿子','女婿儿','儿婿'],
		'd,s':['外孙'],
		'd,s,w':['外孙媳妇','外孙妇'],
		'd,s,s':['外曾孙','重外孙'],
		'd,s,s,w':['外曾孙媳妇','外曾孙妇'],
		'd,s,s,s':['外玄孙'],
		'd,s,s,d':['外玄孙女'],
		'd,s,d':['外曾孙女','重外孙女'],
		'd,s,d,h':['外曾孙女婿','外曾孙婿','重外孙婿'],
		'd,s,d,s':['外玄外孙'],
		'd,s,d,d':['外玄外孙女'],
		'd,d':['外孙女','外孙囡'],
		'd,d,h':['外孙女婿','外孙婿'],
		'd,d,s':['外曾外孙'],
		'd,d,s,w':['外曾外孙妇'],
		'd,d,s,s':['外曾外曾孙'],
		'd,d,s,d':['外曾外曾孙女'],
		'd,d,d':['外曾外孙女'],
		'd,d,d,h':['外曾外孙婿'],
		'd,d,d,s':['外曾外曾外孙'],
		'd,d,d,d':['外曾外曾外孙女'],
		//亲家
		's,w,f':['亲家公','亲家翁','姻翁','亲家','息眷兄','息眷弟'],
		's,w,f,f':['太姻翁'],
		's,w,f,f,f':['老太姻翁'],
		's,w,f,f,m':['老太姻姆'],
		's,w,f,f,xb,s&o':['姻家兄'],
		's,w,f,f,xb,s&l':['姻家弟'],
		's,w,f,f,xb,s,s':['姻侄'],
		's,w,f,f,ob':['姻伯翁'],
		's,w,f,f,ob,w':['姻伯姆'],
		's,w,f,f,lb':['姻叔翁'],
		's,w,f,f,lb,w':['姻叔姆'],
		's,w,f,m':['太姻姆'],
		's,w,f,m,f':['老太姻翁'],
		's,w,f,m,m':['老太姻姆'],
		's,w,f,ob':['姻兄'],
		's,w,f,lb':['姻弟'],
		's,w,f,os':['姻姊'],
		's,w,f,ls':['姻妹'],
		's,w,m':['亲家母','亲家姆','姻姆','亲家','男息姻姊','男息姻妹','息姻姊','息姻妹','息眷姊','息眷妹'],
		's,w,m,ob':['姻仁兄'],
		's,w,m,lb':['姻仁弟'],
		's,w,xb':['男息姻男','息姻男','息眷男'],
		's,w,xb,w':['男息姻妇','息姻妇','息眷妇'],
		's,w,xb,s':['男息姻孙男','息姻孙男','息眷孙男'],
		's,w,xb,d':['男息姻孙女','息姻孙女','息眷孙女'],
		's,w,xs':['男息姻女','息姻女','息眷女'],
		's,w,xs,h':['男息姻婿','息姻婿','息姻婿'],
		's,w,xs,s':['男息姻外孙男','息姻外孙男','息眷外孙男'],
		's,w,xs,d':['男息姻外孙女','息姻外孙女','息眷外孙女'],
		'd,h,f':['亲家公','亲家翁','姻翁','亲家','息姻兄','息姻弟'],
		'd,h,f,f':['太姻翁'],
		'd,h,f,f,f':['老太姻翁'],
		'd,h,f,f,m':['老太姻姆'],
		'd,h,f,f,ob':['姻伯翁'],
		'd,h,f,f,ob,w':['姻伯姆'],
		'd,h,f,f,lb':['姻叔翁'],
		'd,h,f,f,lb,w':['姻叔姆'],
		'd,h,f,m':['太姻姆'],
		'd,h,f,m,f':['老太姻翁'],
		'd,h,f,m,m':['老太姻姆'],
		'd,h,f,f,xb,s&o':['姻家兄'],
		'd,h,f,f,xb,s&l':['姻家弟'],
		'd,h,f,f,xb,s,s':['姻侄'],
		'd,h,f,ob':['女息姻兄','息姻兄'],
		'd,h,f,lb':['女息姻弟','息姻弟'],
		'd,h,f,os':['女息姻姊','息姻姊'],
		'd,h,f,ls':['女息姻妹','息姻妹'],
		'd,h,m':['亲家母','亲家姆','姻姆','亲家','女息姻姊','女息姻妹','息姻姊','息姻妹'],
		'd,h,m,ob':['姻仁兄'],
		'd,h,m,lb':['姻仁弟'],
		'd,h,xb':['女息姻男','息姻男'],
		'd,h,xb,w':['女息姻妇','息姻妇'],
		'd,h,xb,s':['女息姻孙男','息姻孙男'],
		'd,h,xb,d':['女息姻孙女','息姻孙女'],
		'd,h,xs':['女息姻女','息姻女'],
		'd,h,xs,h':['女息姻婿','息姻婿'],
		'd,h,xs,s':['女息姻外孙男','息姻外孙男'],
		'd,h,xs,d':['女息姻外孙女','息姻外孙女'],
	};

	// 数组去重
	var unique = function(arr) {
		var result = [], hash = {};
		var item;
		for (var i = 0; (item = arr[i]) != null; i++) {
			var temp = item.replace(/[ol](?=s|b)/,'x').replace(/&[ol]/,''); //对特殊语法标识相互包含的行为去重
			if (temp==item&&!hash[temp]){
				hash[item] = true;
			}
		}
		for (var i = 0; (item = arr[i]) != null; i++) {
			var temp = item.replace(/[ol](?=s|b)/,'x').replace(/&[ol]/,''); //对特殊语法标识相互包含的行为去重
			if (temp!=item){
				if(!hash[temp]){
					if(result.indexOf(item)==-1){
						result.push(item);
					}
				}
			}else{
				if(result.indexOf(item)==-1){
					result.push(item);
				}
			}
		}
		return result;
	};

	// 中文获取选择器
	function getSelectors(str){
		str = str.replace(/[二|三|四|五|六|七|八|九|十]{1,2}/g,'x');
		var lists = str.replace(/我的?/,'').replace(/家的?/,'的').split('的');
		var result = [];						//所有可能性
		var match = true;
		while(lists.length){
			var name = lists.shift();			//当前匹配词
			var arr = [];						//当前匹配词可能性
			var has = false;
			for(var i in _data){
				var value = _data[i];
				if(value.indexOf(name)>-1){		//是否存在该关系
					if(i||!lists.length){		//对‘我’的优化
						arr.push(i);
					}
					has = true;
				}
			}
			if(!has){
				match = false;
			}
			if(result.length){					//当前匹配词与之前可能性组合
				var res = [];
				for(var i=0;i<result.length;i++){
					for(var j=0;j<arr.length;j++){
						res.push(result[i] +','+arr[j]);
					}
				}
				result = res;
			}else{
				for(var i=0;i<arr.length;i++){
					result.push(','+arr[i]);
				}
			}
		}
		return match?result:[];
	}

	// 选择器转ID
	function selector2id(selector,sex){
		var result = [];
		var hash = {};
		if(sex<0){	
			if(selector.indexOf(',w')==0){
				selector = ',1'+selector;
			}else if(selector.indexOf(',h')==0){
				selector = ',0'+selector;
			}
		}else if(selector.indexOf(',1')==0||selector.indexOf(',0')==0){
		}else if(sex>-1){
			selector = ','+sex+selector;
		}
		// console.log('[selector]',selector);
		if(selector.match(/,[w0],w|,[h1],h/)){	//同志关系去除
			return false;
		}
		var getId = function(selector){
			var s='';
			if(!hash[selector]){
				hash[selector] = true;
				var status = true;
				do{
					s = selector;
					for(var i in _filter){
						var item = _filter[i];
						// console.log('[filter]',item['exp'],selector);
						selector = selector.replace(item['exp'],item['str']);
						if(selector.indexOf('#')>-1){
							var arr = selector.split('#');
							for(var j=0;j<arr.length;j++){
								getId(arr[j]);
							}
							status=false;
							break;
						}
					}
				}while(s!=selector);
				if(status){
					if(selector.match(/,[w0],w|,[h1],h/)){	//同志关系去除
						return false;
					}
					selector = selector.replace(/,[01]/,'').substr(1); 	//去前面逗号和性别信息
					result.push(selector);
				}
			}
		}
		getId(selector);
		return unique(result);
	}

	// 通过ID获取数据
	function getDataById(id){
		var items = [];
		var getData = function(d){
			var res = [];
			for(var i in _data){
				if(i.replace(/&[ol]/g,'')==d){
					res.push(_data[i][0]);
				}else{
					var expr = d;
					while (expr.match(/[ol](b|s)/)){
						expr = expr.replace(/[ol](b|s)/,'x$1');
						if(expr==i){
							res.push(_data[i][0]);
							break;
						}
					}
				}
			}
			return res;
		};
		if(_data[id]){  // 直接匹配称呼
			items.push(_data[id][0]);
		}else{
			items = getData(id);
			// 忽略年龄条件查找
			if(!items.length){
				id = id.replace(/&[ol]/g,'');
				items = getData(id);
			}
			// 忽略年龄条件查找
			if(!items.length){  
				id = id.replace(/[ol](b|s)/g,'x$1');
				items = getData(id);
			}
			// 缩小访问查找
			if(!items.length){
				var l = id.replace(/x/g,'l');
				items = getData(l);
				var o = id.replace(/x/g,'o');
				items = items.concat(getData(o));
			}
		}
		return items;
	}

	// 逆转ID
	function reverseId(id,sex){
		var hash = {
			f:['d','s'],
			m:['d','s'],
			h:['w',''],
			w:['','h'],
			s:['m','f'],
			d:['m','f'],
			lb:['os','ob'],
			ob:['ls','lb'],
			xb:['xs','xb'],
			ls:['os','ob'],
			os:['ls','lb'],
			xs:['xs','xb']
		};
		var age = '';
		if(id.indexOf('&o')>-1){
			age = '&l';
		}else if(id.indexOf('&l')>-1){
			age = '&o';
		}
		if(id){
			id = id.replace(/&[ol]/g,'');
			sex = sex?1:0;		//逆转运算自身性别必须确定
			var sid = (','+sex+','+id).replace(/,[fhs]|,[olx]b/g,',1').replace(/,[mwd]|,[olx]s/g,',0');
			sid = sid.substring(0,sid.lastIndexOf(','));
			var id_arr = id.split(',').reverse();
			var sid_arr = sid.split(',').reverse();
			var arr = [];
			for(var i=0;i<id_arr.length;i++){
				arr.push(hash[id_arr[i]][sid_arr[i]]);
			}
			return arr.join(',')+age;
		}
		return '';
	}

	// 通过ID获取关系链条
	function getChainById(id){
		var arr = id.split(',');
		var items = [];
		for(var i = 0;i<arr.length;i++){
			var key = arr[i].replace(/&[ol]/,'');
			items.push(_data[key][0]);
		}
		return items.join('的');
	}

	// 合并选择器，查找两个对象之间的关系
	function mergeSelector(from,to){
		var Index = 0;
		var from_arr = from.split(',');
		var to_arr = to.split(',');
		for(var i=0;i<from_arr.length&&i<to_arr.length;i++){
			if(from_arr[i]!=to_arr[i]){
				break;
			}
		}
		var mid_sex = -1;
		if(to_arr[i-1]){			
			if(to_arr[i-1].match(/([fhs1](&[ol])?|[olx]b)$/)){
				mid_sex=1;
			}else{
				mid_sex=0;
			}
		}
		var sex = -1;
		if(to){			
			if(to.match(/,([fhs1](&[ol])?|[olx]b)$/)){
				sex=1;
			}else{
				sex=0;
			}
		}
		if(i){	
			var from_sub = from_arr.slice(i).join(',');
			var to_sub = to_arr.slice(i).join(',');
			return {
				'selector':(to_sub?','+reverseId(to_sub,mid_sex):'')+(from_sub?','+from_sub:''),
				'sex':sex
			};
		}else{
			return {
				'selector':from,
				'sex':sex
			};
		}
	}

	return (function (parameter){
		var options = Object.assign({
			text:'',
			target:'',
			sex:-1,
			type:'default',		//为'chain'时,reverse无效
			reverse:false
		},parameter);
		var sex = options.sex;
		var from_selectors = getSelectors(options.text);
		var to_selectors = options.target?getSelectors(options.target):[''];
		// console.log('[selectors]',from_selectors,to_selectors);
		var result = [];							//匹配结果
		from_selectors.forEach(function(from){
			to_selectors.forEach(function(to){
				var data = mergeSelector(from,to);
				 // console.log('[data]',data);
				sex = data['sex']>-1?data['sex']:options.sex;
				var ids = selector2id(data['selector'],sex);
				// console.log('[ids]',ids);
				for(var j=0;j<ids.length;j++){
					var id = ids[j];
					if(options.type=='chain'){
						if(options.reverse){
							id = reverseId(id,sex);
						}
						var item = getChainById(id);
						if(item){
							result.push(item);
						}
					}else{
						if(options.reverse){
							id = reverseId(id,sex);
						}
						var items = getDataById(sex+','+id);
						if(!items.length){
							items = getDataById(id);
						}
						if(!items.length){
							if(id.indexOf('w')==0||id.indexOf('h')==0){  //找不到关系，随爱人叫
								items = getDataById(id.substr(2));
							}
						}
						if(items.length){
							result = result.concat(items);
						}
					}
				}
			});
		});
		return unique(result);
	});
});
